// (C) 2001-2020 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.



`timescale 1 ps / 1 ps
module hdmi_rx_altera_hdmi_1940_g5zh3uy #(
   parameter       FAMILY                = "Stratix 10",
   parameter       SYMBOLS_PER_CLOCK     = 2,
   parameter       DISABLE_ALIGN_DESKEW  = 0,
   parameter       ENABLE_FAST_ALIGNMENT = 0,
   parameter       SUPPORT_AUXILIARY     = 1,
   parameter       SUPPORT_DEEP_COLOR    = 1,
   parameter       SUPPORT_AUDIO         = 1,
   parameter       SUPPORT_32CHAN_AUDIO  = 0,
   parameter       SUPPORT_HDCP2X        = 0,
   parameter       SUPPORT_HDCP1X        = 0,
   parameter[23:0] SCDC_IEEE_ID          = 0,
   parameter[63:0] SCDC_DEVICE_STRING    = 0,
   parameter[7:0]  SCDC_HW_REVISION      = 0,
   parameter       PIXELS_PER_CLOCK      = 2,
   parameter       SYMBOLS_PER_CLOCK_20  = 2,
   parameter       SYMBOLS_PER_CLOCK_21  = 2,
   parameter       SYMBOLS_PER_CLOCK_FRL = 16,
   parameter       SUPPORT_FRL           = 0,
   parameter       TRANSCEIVER_WIDTH     = 20 
)(
   input  wire                              reset,
   input  wire                              reset_vid,
   input  wire                              vid_clk,
   input  wire                              ls_clk,
   output wire                              locked,
   output wire                              mode,
   output wire [(6*SYMBOLS_PER_CLOCK)-1:0]  ctrl,
   output wire                              vid_lock,
   output wire [(1*SYMBOLS_PER_CLOCK)-1:0]  vid_de,
   output wire [(48*SYMBOLS_PER_CLOCK)-1:0] vid_data,
   output wire [(1*SYMBOLS_PER_CLOCK)-1:0]  vid_hsync,
   output wire [(1*SYMBOLS_PER_CLOCK)-1:0]  vid_vsync,
   input  wire [TRANSCEIVER_WIDTH-1:0]      in_b,
   input  wire [TRANSCEIVER_WIDTH-1:0]      in_r,
   input  wire [TRANSCEIVER_WIDTH-1:0]      in_g,
   input  wire                              in_lock,
   output wire                              aux_valid,
   output wire [71:0]                       aux_data,
   output wire                              aux_sop,
   output wire                              aux_eop,
   output wire                              aux_error,
   output wire [5:0]                        gcp,
   output wire [111:0]                      info_avi,
   output wire [60:0]                       info_vsi,
   output wire [6:0]                        aux_pkt_addr,
   output wire [71:0]                       aux_pkt_data,
   output wire                              aux_pkt_wr,
   output wire [19:0]                       audio_CTS,
   output wire [19:0]                       audio_N,
   output wire [255:0]                      audio_data,
   output wire                              audio_de,
   output wire [47:0]                       audio_info_ai,
   output wire [164:0]                      audio_metadata,
   output wire [4:0]                        audio_format,
   input  wire                              scdc_i2c_clk,
   input  wire [7:0]                        scdc_i2c_addr,
   input  wire [7:0]                        scdc_i2c_wdata,
   input  wire                              scdc_i2c_r,
   input  wire                              scdc_i2c_w,
   output wire [7:0]                        scdc_i2c_rdata,
   input  wire                              hdcp_reset,
   input  wire                              hdcp_i2c_clk,
   input  wire                              crypto_clk,
   input  wire                              hdcp_i2c_stop_det,
   input  wire                              hdcp_i2c_wr,
   input  wire                              hdcp_i2c_rd,
   input  wire [7:0]                        hdcp_i2c_addr,
   input  wire [7:0]                        hdcp_i2c_wrdata,
   output wire [7:0]                        hdcp_i2c_rddata,
   input  wire                              rpt_msg_clk,
   input  wire                              rpt_msg_wr,
   input  wire                              rpt_msg_rd,
   input  wire [7:0]                        rpt_msg_addr,
   input  wire [31:0]                       rpt_msg_wrdata,
   output wire [31:0]                       rpt_msg_rddata,
   output wire                              hdcp1_enabled,
   output wire                              hdcp2_enabled, 
   output wire                              streamid_type,
   output wire [13:0]                       kmem_rdaddr, 
   input  wire [87:0]                       kmem_q,
   input  wire [1:0]                        kmem_wait,
   output wire                              TMDS_Bit_clock_Ratio,
   input  wire                              in_5v_power,
   input  wire                              in_hpd
);


   bitec_hdmi_rx #(
      .FAMILY               (FAMILY),
      .SUPPORT_HDCP1X       (SUPPORT_HDCP1X),
      .SUPPORT_HDCP2X       (SUPPORT_HDCP2X),
      .SYMBOLS_PER_CLOCK    (SYMBOLS_PER_CLOCK),
      .DISABLE_ALIGN_DESKEW (DISABLE_ALIGN_DESKEW),
      .SUPPORT_AUXILIARY    (SUPPORT_AUXILIARY),
      .SUPPORT_DEEP_COLOR   (SUPPORT_DEEP_COLOR),
      .SUPPORT_AUDIO        (SUPPORT_AUDIO),
      .SUPPORT_32CHAN_AUDIO (SUPPORT_32CHAN_AUDIO),
      .SCDC_IEEE_ID         (SCDC_IEEE_ID),
      .SCDC_DEVICE_STRING   (SCDC_DEVICE_STRING),
      .SCDC_HW_REVISION     (SCDC_HW_REVISION)
   ) u_bitec_hdmi_rx (
      .reset                (reset),               
      .reset_vid            (reset_vid),
      .vid_clk              (vid_clk),             
      .ls_clk               ({3{ls_clk}}),              
      .locked               (locked),              
      .mode                 (mode),                
      .ctrl                 (ctrl),                
      .vid_lock             (vid_lock),            
      .vid_de               (vid_de),              
      .vid_data             (vid_data),            
      .vid_hsync            (vid_hsync),           
      .vid_vsync            (vid_vsync),           
      .in_b                 (in_b),                
      .in_r                 (in_r),                
      .in_g                 (in_g),                
      .in_lock              ({3{in_lock}}),        
      .aux_valid            (aux_valid),           
      .aux_data             (aux_data),            
      .aux_sop              (aux_sop),             
      .aux_eop              (aux_eop),             
      .aux_error            (aux_error),           
      .gcp                  (gcp),                 
      .info_avi             (info_avi),            
      .info_vsi             (info_vsi),            
      .aux_pkt_addr         (aux_pkt_addr),        
      .aux_pkt_data         (aux_pkt_data),        
      .aux_pkt_wr           (aux_pkt_wr),          
      .audio_CTS            (audio_CTS),           
      .audio_N              (audio_N),             
      .audio_data           (audio_data),          
      .audio_de             (audio_de),            
      .audio_info_ai        (audio_info_ai),       
      .audio_metadata       (audio_metadata),      
      .audio_format         (audio_format),        
      .scdc_i2c_clk         (scdc_i2c_clk),        
      .scdc_i2c_addr        (scdc_i2c_addr),       
      .scdc_i2c_wdata       (scdc_i2c_wdata),
      .scdc_i2c_r           (scdc_i2c_r), 
      .scdc_i2c_w           (scdc_i2c_w),
      .scdc_i2c_rdata       (scdc_i2c_rdata),
      .TMDS_Bit_clock_Ratio      (TMDS_Bit_clock_Ratio),
      .vde_to_hdcp          (),
      .vdata_to_hdcp        (),
      .ade_to_hdcp          (),
      .adata_to_hdcp        (),
      .hsync_to_hdcp        (),
      .vsync_to_hdcp        (),
      .ctl_to_hdcp          (),
      .vde_from_hdcp        ({SYMBOLS_PER_CLOCK* 1{1'b0}}),
      .vdata_from_hdcp      ({SYMBOLS_PER_CLOCK*24{1'b0}}),
      .ade_from_hdcp        ({SYMBOLS_PER_CLOCK* 1{1'b0}}),
      .adata_from_hdcp      ({SYMBOLS_PER_CLOCK*12{1'b0}}),
      .hsync_from_hdcp      ({SYMBOLS_PER_CLOCK* 1{1'b0}}),
      .vsync_from_hdcp      ({SYMBOLS_PER_CLOCK* 1{1'b0}}),
      .ctl_from_hdcp        ({SYMBOLS_PER_CLOCK* 6{1'b0}}),
      .set_avmute_to_hdcp   (),
      .clear_avmute_to_hdcp (),
      .in_5v_power          (in_5v_power),
      .in_hpd               (in_hpd),
      .version              (),
      .raw_data             (),
      .err_count_b          (),
      .err_count_g          (),
      .err_count_r          ()
   );

   assign hdcp1_enabled         = 1'b0;
   assign hdcp2_enabled         = 1'b0;
   assign hdcp_i2c_rddata       = 8'b0;
   assign kmem_rdaddr           = 14'b0;
   assign rpt_msg_rddata        = 32'b0;
   assign streamid_type         = 1'b0;

endmodule

