// (C) 2001-2020 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


module shift #(parameter WIDTH = 1, parameter DEPTH = 0) (
    input logic clk,
    input logic [WIDTH-1:0] din,
    output logic [WIDTH-1:0] dout
);

logic [WIDTH-1:0] shift_register [DEPTH-1:0];

integer i;
generate
if (DEPTH == 0)
begin
    always_comb
    begin
        dout = din;
    end
end
else
begin
    always_ff @(posedge clk)
    begin
        shift_register[0] <= din;
        for (i = 1; i < DEPTH; i = i + 1)
        begin
            shift_register[i] <= shift_register[i-1]; 
        end
    end

    always_comb
    begin
        dout = shift_register[DEPTH-1];
    end
end
endgenerate

endmodule 
