// (C) 2001-2020 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.

//`define ENABLE_DDR4A
//`define ENABLE_DDR4B
`define ENABLE_FMC
`define ENABLE_FMCP
`define ENABLE_HDMI_TX
//`define ENABLE_PCIE
//`define ENABLE_QSFP28A
//`define ENABLE_QSFP28B
//`define ENABLE_HPS


//`define SEPARATE_RCFG_INTF_EN
`ifdef SEPARATE_RCFG_INTF_EN
    `define SEPARATE_RCFG_INTF 1
`else
    `define SEPARATE_RCFG_INTF 0
`endif

module s10_hdmi2_demo (


      ///////// CLOCK /////////
      input              CLK_100_B3I,
      input              CLK_50_B2F,
      input              CLK_50_B2L,
      input              CLK_50_B3C,
      input              CLK_50_B3I,
      input              LVDS_REFCLK_p,

      ///////// Buttons /////////
      input              CPU_RESET_n,
      input    [ 1: 0]   BUTTON,

      ///////// Swtiches /////////
      input    [ 1: 0]   SW,

      ///////// LED /////////
      output   [ 1: 0]   LED, //LED is Low-Active

`ifdef ENABLE_DDR4A
      ///////// DDR4A /////////
      input              DDR4A_REFCLK_p,
      output   [17: 0]   DDR4A_A,
      output   [ 1: 0]   DDR4A_BA,
      output   [ 1: 0]   DDR4A_BG,
      output             DDR4A_CK,
      output             DDR4A_CK_n,
      output   [ 1: 0]   DDR4A_CKE,
      inout    [ 8: 0]   DDR4A_DQS,
      inout    [ 8: 0]   DDR4A_DQS_n,
      inout    [71: 0]   DDR4A_DQ,
      inout    [ 8: 0]   DDR4A_DBI_n,
      output   [ 1: 0]   DDR4A_CS_n,
      output             DDR4A_RESET_n,
      output   [ 1: 0]   DDR4A_ODT,
      output             DDR4A_PAR,
      input              DDR4A_ALERT_n,
      output             DDR4A_ACT_n,
      input              DDR4A_RZQ,
`endif /*ENABLE_DDR4A*/

`ifdef ENABLE_DDR4B
      ///////// DDR4B /////////
      input              DDR4B_REFCLK_p,
      output   [17: 0]   DDR4B_A,
      output   [ 1: 0]   DDR4B_BA,
      output   [ 1: 0]   DDR4B_BG,
      output             DDR4B_CK,
      output             DDR4B_CK_n,
      output   [ 1: 0]   DDR4B_CKE,
      inout    [ 8: 0]   DDR4B_DQS,
      inout    [ 8: 0]   DDR4B_DQS_n,
      inout    [71: 0]   DDR4B_DQ,
      inout    [ 8: 0]   DDR4B_DBI_n,
      output   [ 1: 0]   DDR4B_CS_n,
      output             DDR4B_RESET_n,
      output   [ 1: 0]   DDR4B_ODT,
      output             DDR4B_PAR,
      input              DDR4B_ALERT_n,
      output             DDR4B_ACT_n,
      input              DDR4B_RZQ,
`endif /*ENABLE_DDR4B*/

      ///////// SI5341A /////////
      inout              SI5341A_I2C_SCL,
      inout              SI5341A_I2C_SDA,
      output             SI5341A_OE_n,
      output             SI5341A_RST_n,

`ifdef ENABLE_FMC
      ///////// FMC /////////
      input    [ 1: 0]   S10B_KEY,
      input    [ 1: 0]   S10B_SW,
      output   [ 3: 0]   S10B_LED,
      inout    [35: 0]   FMC_GPIO_D,
`endif /*ENABLE_FMC*/

`ifdef ENABLE_FMCP
      ///////// FMCP /////////
      input              FMCP_REFCLK_p,
      inout              FMCP_SCL,                    //Si5340A_I2C_SCL, HDMI_IC_SCL, HDMI_DDC_SCL, HDMI_REFCLK_SCL
      inout              FMCP_SDA,                    //Si5340A_I2C_SDA, HDMI_IC_SDA, HDMI_DDC_SDA, HDMI_REFCLK_SDA
      output             SI5340A_OE_n,
      output             SI5340A_RST_n,

`ifdef ENABLE_HDMI_TX     
      inout              HDMI_TX_CEC,
      input              HDMI_TX_HPD,
      input              HDMI_REFCLK_p,
      output             HDMI_TX_CLK_p,
      output   [ 2: 0]   HDMI_TX_D_p,
`endif /*ENABLE_HDMI_TX*/

`ifdef ENABLE_PCIE        
      input              DG_PCIe_RST_n,
      output             DG_PEWAKE_n_FMCP,
      input              DG_PM_S0_EN_FMCP,
      input              DG_PM_S3_EN_FMCP,
      input              PCIE_REFCLK_p,
      input    [ 3: 0]   PCIE_RX_p,
      output   [ 3: 0]   PCIE_TX_p,
`endif /*ENABLE_PCIE*/

`ifdef ENABLE_QSFP28A
      input              QSFP28A_INTERRUPT_n,
      output             QSFP28A_LP_MODE,
      input              QSFP28A_MOD_PRS_n,
      output             QSFP28A_MOD_SEL_n,
      output             QSFP28A_RST_n,
      inout              QSFP28A_SCL,
      inout              QSFP28A_SDA,
      input              QSFP28A_REFCLK_p,
      input    [ 3: 0]   QSFP28A_RX_p,
      output   [ 3: 0]   QSFP28A_TX_p,
`endif /*ENABLE_QSFP28A*/

`ifdef ENABLE_QSFP28B
      input              QSFP28B_INTERRUPT_n,
      output             QSFP28B_LP_MODE,
      input              QSFP28B_MOD_PRS_n,
      output             QSFP28B_MOD_SEL_n,
      output             QSFP28B_RST_n,
      inout              QSFP28B_SCL,
      inout              QSFP28B_SDA,
      input              QSFP28B_REFCLK_p,
      input    [ 3: 0]   QSFP28B_RX_p,
      output   [ 3: 0]   QSFP28B_TX_p,
`endif /*ENABLE_QSFP28B*/
`endif /*ENABLE_FMCP*/

`ifdef ENABLE_HPS
      ///////// HPS /////////
      output             HPS_ENET_MDC,
      inout              HPS_ENET_MDIO,
      input              HPS_ENET_RX_CLK,
      input              HPS_ENET_RX_CTL,
      input    [ 3: 0]   HPS_ENET_RX_DATA,
      output             HPS_ENET_TX_CLK,
      output             HPS_ENET_TX_CTL,
      output   [ 3: 0]   HPS_ENET_TX_DATA,
      inout    [ 3: 0]   HPS_GPIO,
      inout              HPS_I2C_SCL,
      inout              HPS_I2C_SDA,
      inout              HPS_KEY,
      inout              HPS_LED,
      input              HPS_OSC_CLK,
      output             HPS_SD_CLK,
      inout              HPS_SD_CMD,
      inout    [ 3: 0]   HPS_SD_DATA,
      input              HPS_UART_RX,
      output             HPS_UART_TX,
      input              HPS_USB_CLK,
      inout    [ 7: 0]   HPS_USB_DATA,
      input              HPS_USB_DIR,
      input              HPS_USB_NXT,
      output             HPS_USB_STP,
`endif /*ENABLE_HPS*/

      ///////// S10MAX10 /////////
      output             INFO_SPI_SCLK, 
      output             INFO_SPI_CS_n, 
      output             INFO_SPI_MOSI, 
      input              INFO_SPI_MISO 

	
);

localparam SYMBOLS_PER_CLOCK = 2;
localparam SUPPORT_AUDIO = 1;
localparam SUPPORT_AUXILIARY = 1;
localparam SUPPORT_DEEP_COLOR = 1;

//valid value: 4, 6, 11, 0 (no configuration change due to schematics)
localparam BITEC_DAUGHTER_CARD_REV = 6;

//Invert polarity due to the polarity inversion on the Bitec HDMI FMC daugther card, you should disable this if the polarity inversion is not required
localparam TX_POLARITY_INVERSION = (BITEC_DAUGHTER_CARD_REV==6 || BITEC_DAUGHTER_CARD_REV==4)? 1 : 
                                   (BITEC_DAUGHTER_CARD_REV==11)? 0 : 0;
localparam RX_POLARITY_INVERSION = (BITEC_DAUGHTER_CARD_REV==6 || BITEC_DAUGHTER_CARD_REV==4)? 1 : 
                                   (BITEC_DAUGHTER_CARD_REV==11)? 0 : 0;
	  
wire clk100;
assign clk100 = CLK_100_B3I;

// -------------------------------------------------------------------------------
// Wait for device ready
// -------------------------------------------------------------------------------
wire device_ready;
device_init #(
  .CNTR_BITS  (16)
) device_init_inst (
  .clk (clk100),
  .init_done  (device_ready)
);

wire                                   sys_init;
wire                                   mgmt_clk_reset_sync;
wire [SYMBOLS_PER_CLOCK*48-1:0]        hdmi_rx_data;
wire [SYMBOLS_PER_CLOCK-1:0]           hdmi_rx_vsync;
wire [SYMBOLS_PER_CLOCK-1:0]           hdmi_rx_hsync;
wire [SYMBOLS_PER_CLOCK-1:0]           hdmi_rx_de;
wire                                   hdmi_rx_vid_clk;
wire                                   hdmi_rx_ls_clk;
wire                                   hdmi_rx_iopll_locked;
wire                                   gxb_rx_ready;
wire [23:0]                            measure;
wire                                   measure_valid;
wire                                   rx_os;
wire [1:0]                             tx_os;
wire                                   tx_audio_de;
wire [255:0]                           tx_audio_data;
wire [47:0]                            tx_audio_info_ai;
wire [19:0]                            tx_audio_N;
wire [19:0]                            tx_audio_CTS;
wire [164:0]                           tx_audio_metadata;
wire [4:0]                             tx_audio_format;
wire [111:0]                           tx_info_avi;
wire [60:0]                            tx_info_vsi;
wire                                   rx_audio_de;
wire [255:0]                           rx_audio_data;
wire [47:0]                            rx_audio_info_ai;
wire [19:0]                            rx_audio_N;
wire [19:0]                            rx_audio_CTS;
wire [164:0]                           rx_audio_metadata;
wire [4:0]                             rx_audio_format;
wire [111:0]                           rx_info_avi;
wire [60:0]                            rx_info_vsi;
wire                                   TMDS_Bit_clock_Ratio;
wire                                   reset;
wire                                   hpd;
wire                                   rx_hpd;
wire                                   rx_hdmi_locked;
wire                                   rx_iopll_locked;
wire                                   rx_ready;
wire                                   tx_ready;
wire                                   tx_iopll_locked;
wire                                   tx_pll_locked;

wire                                   cpu_clk_reset_n;
wire                                   i2c_clk_reset_sync;
wire                                   tx_hpd_ack;
wire                                   tx_hpd_req;
wire  [23:0]                           reserve_writedata;



assign S10B_LED[0] = ~tx_iopll_locked;
assign S10B_LED[1] = ~tx_ready;
assign S10B_LED[2] = ~tx_pll_locked;
assign S10B_LED[3] = ~tx_os;
assign LED[0] = ~|tx_os;
assign LED[1] = ~tx_ready; 
//assign user_led_g[6] = ~tx_pll_locked; 
//assign user_led_g[7] = ~|tx_os;
assign reset         = ~CPU_RESET_n | ~device_ready;
assign user_pb_0    = S10B_KEY[0];


wire tmds_clk_in;
wire hdmi_clk_in;
wire mgmt_clk;
assign tmds_clk_in = HDMI_REFCLK_p;
assign hdmi_clk_in = tmds_clk_in;
assign mgmt_clk = clk100;


wire i2c_clk;
assign i2c_clk = clk100;


wire [5:0]  tx_gcp;
wire [71:0] tx_aux_data;
wire        tx_aux_valid;
wire        tx_aux_sop;
wire        tx_aux_eop;
wire        tx_aux_ready;

//
// Qsys system for TX reconfig & I2C master (TX DDC)
// Placeholder for VIP passthrough system
//
wire                            tx_rst_pll;
wire                            tx_rst_xcvr;
wire                            wd_reset;
wire                            hdmi_tx_vid_clk;
wire                            hdmi_tx_ls_clk;
wire [48*SYMBOLS_PER_CLOCK-1:0] hdmi_tx_data;
wire [1*SYMBOLS_PER_CLOCK-1:0]  hdmi_tx_vsync;
wire [1*SYMBOLS_PER_CLOCK-1:0]  hdmi_tx_hsync;
wire [1*SYMBOLS_PER_CLOCK-1:0]  hdmi_tx_de;
wire [10:0]                     tx_pll_reconfig_mgmt_address;
wire                            tx_pll_reconfig_mgmt_waitrequest;
wire                            tx_pll_reconfig_mgmt_write;
wire [31:0]                     tx_pll_reconfig_mgmt_writedata;
wire                            tx_pll_reconfig_mgmt_read;
wire [31:0]                     tx_pll_reconfig_mgmt_readdata;
wire [9:0]                      tx_iopll_reconfig_mgmt_address;
wire                            tx_iopll_reconfig_mgmt_waitrequest;
wire                            tx_iopll_reconfig_mgmt_write;
wire [31:0]                     tx_iopll_reconfig_mgmt_writedata;
wire                            tx_iopll_reconfig_mgmt_read;
wire [31:0]                     tx_iopll_reconfig_mgmt_readdata;

wire [10:0]                     tx_pma_rcfg_mgmt_address;
wire [12:0]                     tx_pma_rcfg_mgmt_translator_avalon_anti_slave_address;
wire                            tx_pma_rcfg_mgmt_write;
wire                            tx_pma_rcfg_mgmt_read;
wire [31:0]                     tx_pma_rcfg_mgmt_readdata;
wire [31:0]                     tx_pma_rcfg_mgmt_writedata;
wire                            tx_pma_rcfg_mgmt_waitrequest;
wire                            tx_reconfig_en;
wire [1:0]                      tx_pma_ch;

wire                            tx_measure_valid_ack;
wire                            tx_measure_valid_req;
wire  [23:0]                    tx_measure;
wire nios_tx_i2c_sda_in;
wire nios_tx_i2c_scl_in;
wire nios_tx_i2c_sda_oe;
wire nios_tx_i2c_scl_oe;

wire nios_ti_i2c_sda_in;
wire nios_ti_i2c_scl_in;
wire nios_ti_i2c_sda_oe;
wire nios_ti_i2c_scl_oe;
		
		
//wire [3*8*SYMBOLS_PER_CLOCK-1:0] cvi_data_in;
//wire [3*8*SYMBOLS_PER_CLOCK-1:0] cvo_data_out;
wire [47:0] cvo_data_out;
wire [1:0]  cvo_de;
wire [1:0]  cvo_vsync;
wire [1:0]  cvo_hsync;
wire [3:0]    gxb_tx_cal_busy_in;

assign cpu_clk_reset_n = ~(reset | wd_reset | sys_init);



    Test_Pattern Test_Pattern_inst (
        .alt_vip_cl_cvo_clocked_video_vid_clk       (hdmi_tx_vid_clk),       //   input,   width = 1, alt_vip_cl_cvo_clocked_video.vid_clk
        .alt_vip_cl_cvo_clocked_video_vid_data      (hdmi_tx_data),      //  output,  width = 30,                             .vid_data
        .alt_vip_cl_cvo_clocked_video_underflow     (),     //  output,   width = 1,                             .underflow
        .alt_vip_cl_cvo_clocked_video_vid_datavalid (hdmi_tx_de), //  output,   width = 1,                             .vid_datavalid
        .alt_vip_cl_cvo_clocked_video_vid_v_sync    (hdmi_tx_vsync),    //  output,   width = 1,                             .vid_v_sync
        .alt_vip_cl_cvo_clocked_video_vid_h_sync    (hdmi_tx_hsync),    //  output,   width = 1,                             .vid_h_sync
        .alt_vip_cl_cvo_clocked_video_vid_f         (),         //  output,   width = 1,                             .vid_f
        .alt_vip_cl_cvo_clocked_video_vid_h         (),         //  output,   width = 1,                             .vid_h
        .alt_vip_cl_cvo_clocked_video_vid_v         (),         //  output,   width = 1,                             .vid_v
        .clock_in_clk_clk                           (CLK_50_B2F),                           //   input,   width = 1,                 clock_in_clk.clk
        .reset_in_reset_reset_n                     (~reset)                      //   input,   width = 1,               reset_in_reset.reset_n
    );


nios u_nios (
   /* I */ .clock_bridge_0_in_clk_clk (clk100),
   /* I */ .reset_bridge_0_in_reset_reset_n (cpu_clk_reset_n),
   /* I */ .tmds_bit_clock_ratio_pio_external_connection_export (TMDS_Bit_clock_Ratio), 
   /* I */ .measure_pio_external_connection_export (1485000),
   /* I */ .measure_valid_req_export (tx_measure_valid_req),
   /* O */ .measure_valid_ack_export (tx_measure_valid_ack),

   /* I */ .i2c_master_i2c_serial_sda_in(nios_tx_i2c_sda_in),
   /* I */ .i2c_master_i2c_serial_scl_in(nios_tx_i2c_scl_in),
   /* O */ .i2c_master_i2c_serial_sda_oe(nios_tx_i2c_sda_oe),
   /* O */ .i2c_master_i2c_serial_scl_oe(nios_tx_i2c_scl_oe),
   
   /* I */ .i2c_master_ti_i2c_serial_sda_in(nios_ti_i2c_sda_in),
   /* I */ .i2c_master_ti_i2c_serial_scl_in(nios_ti_i2c_scl_in),
   /* O */ .i2c_master_ti_i2c_serial_sda_oe(nios_ti_i2c_sda_oe),
   /* O */ .i2c_master_ti_i2c_serial_scl_oe(nios_ti_i2c_scl_oe),
  
   /* O */ .edid_ram_access_pio_external_connection_export(rx_edid_ram_access),
   /* O */ .edid_ram_slave_translator_address (rx_edid_ram_address),
   /* O */ .edid_ram_slave_translator_write (rx_edid_ram_write),
   /* O */ .edid_ram_slave_translator_read (rx_edid_ram_read),
   /* I */ .edid_ram_slave_translator_readdata (rx_edid_ram_readdata),
   /* O */ .edid_ram_slave_translator_writedata (rx_edid_ram_writedata),
   /* I */ .edid_ram_slave_translator_waitrequest (rx_edid_ram_waitrequest),

   /* I */ .color_depth_pio_external_connection_export (color_depth_sync),	
   /* I */ .tx_iopll_waitrequest_pio_external_connection_export (tx_iopll_reconfig_mgmt_waitrequest),
   /* I */ .tx_pll_waitrequest_pio_external_connection_export (tx_pll_reconfig_mgmt_waitrequest),
   /* I */ .tx_hpd_req_pio_external_connection_export (tx_hpd_req),
   /* O */ .tx_hpd_ack_pio_external_connection_export (tx_hpd_ack),					     
   /* I */ .tx_pll_rcfg_mgmt_translator_avalon_anti_slave_waitrequest (tx_pll_reconfig_mgmt_waitrequest),
   /* O */ .tx_pll_rcfg_mgmt_translator_avalon_anti_slave_writedata (tx_pll_reconfig_mgmt_writedata),
   /* O */ .tx_pll_rcfg_mgmt_translator_avalon_anti_slave_address (tx_pll_reconfig_mgmt_address),
   /* O */ .tx_pll_rcfg_mgmt_translator_avalon_anti_slave_write (tx_pll_reconfig_mgmt_write),
   /* O */ .tx_pll_rcfg_mgmt_translator_avalon_anti_slave_read (tx_pll_reconfig_mgmt_read),
   /* I */ .tx_pll_rcfg_mgmt_translator_avalon_anti_slave_readdata (tx_pll_reconfig_mgmt_readdata),					     
   /* O */ .tx_iopll_rcfg_mgmt_translator_avalon_anti_slave_writedata (tx_iopll_reconfig_mgmt_writedata),
   /* O */ .tx_iopll_rcfg_mgmt_translator_avalon_anti_slave_address (tx_iopll_reconfig_mgmt_address),
   /* O */ .tx_iopll_rcfg_mgmt_translator_avalon_anti_slave_write (tx_iopll_reconfig_mgmt_write),
   /* O */ .tx_iopll_rcfg_mgmt_translator_avalon_anti_slave_read (tx_iopll_reconfig_mgmt_read),
   /* I */ .tx_iopll_rcfg_mgmt_translator_avalon_anti_slave_readdata (tx_iopll_reconfig_mgmt_readdata),
   
   /* O */ .tx_pma_rcfg_mgmt_translator_avalon_anti_slave_address(tx_pma_rcfg_mgmt_translator_avalon_anti_slave_address),
   /* O */ .tx_pma_rcfg_mgmt_translator_avalon_anti_slave_write(tx_pma_rcfg_mgmt_write),
   /* O */ .tx_pma_rcfg_mgmt_translator_avalon_anti_slave_read(tx_pma_rcfg_mgmt_read),
   /* I */ .tx_pma_rcfg_mgmt_translator_avalon_anti_slave_readdata(tx_pma_rcfg_mgmt_readdata),
   /* O */ .tx_pma_rcfg_mgmt_translator_avalon_anti_slave_writedata(tx_pma_rcfg_mgmt_writedata),
   /* I */ .tx_pma_rcfg_mgmt_translator_avalon_anti_slave_waitrequest(tx_pma_rcfg_mgmt_waitrequest),
   /* I */ .tx_pma_waitrequest_pio_external_connection_export(tx_pma_rcfg_mgmt_waitrequest),
   /* I */ .tx_pma_cal_busy_pio_external_connection_export( {|gxb_tx_cal_busy_in} ),
   /* O */ .tx_pma_ch_export(tx_pma_ch),
   
   /* O */ .tx_rcfg_en_pio_external_connection_export(tx_reconfig_en),
   /* O */ .tx_os_pio_external_connection_export (tx_os),
   /* O */ .tx_rst_pll_pio_external_connection_export (tx_rst_pll),
   /* O */ .tx_rst_xcvr_pio_external_connection_export (tx_rst_xcvr),
   /* O */ .wd_timer_resetrequest_reset (wd_reset)
);

wire [3:0]  tx_serial_data;  

wire [3:0]    gxb_tx_reconfig_write;
wire [3:0]    gxb_tx_reconfig_read;
wire [43:0]   gxb_tx_reconfig_address;
wire [127:0]  gxb_tx_reconfig_writedata;
wire [127:0]  gxb_tx_reconfig_readdata;
wire [3:0]    gxb_tx_reconfig_waitrequest;
wire [3:0]    gxb_tx_cal_busy_out;

wire          tx_reset_pll_reconfig;
assign tx_reset_pll_reconfig = sys_init | wd_reset;
assign TMDS_Bit_clock_Ratio = 1'b1;

hdmi_tx_top #(
   .SUPPORT_DEEP_COLOR (SUPPORT_DEEP_COLOR),
   .SUPPORT_AUXILIARY (SUPPORT_AUXILIARY),
   .SYMBOLS_PER_CLOCK (SYMBOLS_PER_CLOCK),
   .SUPPORT_AUDIO (SUPPORT_AUDIO),
   .POLARITY_INVERSION (0),
   .BITEC_DAUGHTER_CARD_REV (BITEC_DAUGHTER_CARD_REV)
) u_hdmi_tx_top (
   /* I */ .mgmt_clk (mgmt_clk),
   /* I */ .reset (reset),
   /* I */ .hdmi_clk_in (hdmi_clk_in),
   /* O */ .vid_clk_out (hdmi_tx_vid_clk),
   /* O */ .ls_clk_out (hdmi_tx_ls_clk),		 
   /* O */ .iopll_locked (tx_iopll_locked),
   /* O */ .txpll_locked (tx_pll_locked),
   /* O */ .gxb_tx_ready (tx_ready),
   /* I */ .reset_xcvr (tx_rst_xcvr),  
   /* I */ .reset_pll (tx_rst_pll),  
   /* I */ .reset_pll_reconfig (tx_reset_pll_reconfig),
   /* I */ .sys_init (sys_init),
   
   /* O */ .nios_tx_i2c_sda_in(nios_tx_i2c_sda_in),
   /* O */ .nios_tx_i2c_scl_in(nios_tx_i2c_scl_in),
   /* I */ .nios_tx_i2c_sda_oe(nios_tx_i2c_sda_oe),
   /* I */ .nios_tx_i2c_scl_oe(nios_tx_i2c_scl_oe),
   
   /* O */ .nios_ti_i2c_sda_in(nios_ti_i2c_sda_in),
   /* O */ .nios_ti_i2c_scl_in(nios_ti_i2c_scl_in),
   /* I */ .nios_ti_i2c_sda_oe(nios_ti_i2c_sda_oe),
   /* I */ .nios_ti_i2c_scl_oe(nios_ti_i2c_scl_oe),

   /* O */ .tx_serial_data (tx_serial_data[3:0]),
   /* I */ .tx_pll_reconfig_write (tx_pll_reconfig_mgmt_write),
   /* I */ .tx_pll_reconfig_read (tx_pll_reconfig_mgmt_read),
   /* I */ .tx_pll_reconfig_address (tx_pll_reconfig_mgmt_address),
   /* I */ .tx_pll_reconfig_writedata (tx_pll_reconfig_mgmt_writedata),
   /* O */ .tx_pll_reconfig_readdata (tx_pll_reconfig_mgmt_readdata),
   /* O */ .tx_pll_reconfig_waitrequest (tx_pll_reconfig_mgmt_waitrequest),
   /* I */ .pll_reconfig_write (tx_iopll_reconfig_mgmt_write),
   /* I */ .pll_reconfig_read (tx_iopll_reconfig_mgmt_read),
   /* I */ .pll_reconfig_address (tx_iopll_reconfig_mgmt_address),
   /* I */ .pll_reconfig_writedata (tx_iopll_reconfig_mgmt_writedata),
   /* O */ .pll_reconfig_readdata (tx_iopll_reconfig_mgmt_readdata),
   /* O */ .pll_reconfig_waitrequest (tx_iopll_reconfig_mgmt_waitrequest),
   /* I */ .os (tx_os), 
   /* I */ .mode (1'b1), 
   /* I */ .ctrl ({SYMBOLS_PER_CLOCK{6'd0}}),					
   /* I */ .aux_data (tx_aux_data),
   /* I */ //.aux_valid (tx_aux_valid & ~ext_aux_block),
   /* I */ .aux_valid (tx_aux_valid),
   /* O */ .aux_ready (tx_aux_ready),
   /* I */ .aux_sop (tx_aux_sop),
   /* I */ .aux_eop (tx_aux_eop),
   /* I */ .gcp (6'h20),
           // Press user_pb[2], you will no longer see infoframes in the transmitted signal
           // Release user_pb[2], you will see continuous infoframes in the transmitted signal
   /* I */ .info_avi ({1'b0, 112'h802802C5}),
   /* I */ .info_vsi ({1'b0, 60'h240001806906}),
   /* I */ //.audio_clk (),
   /* I */ .audio_de (tx_audio_de),
   /* I */ .audio_mute (1'b0),
   /* I */ .audio_CTS (tx_audio_CTS),
   /* I */ .audio_data (tx_audio_data), 
   /* I */ .audio_info_ai ({1'b1, tx_audio_info_ai}), 
   /* I */ .audio_N (tx_audio_N), 
   /* I */ .audio_metadata ({1'b1, tx_audio_metadata}),
   /* I */ .audio_format (tx_audio_format),
	/* I */ .vid_data (hdmi_tx_data), // use tpg: hdmi_tx_data_from_cvo    
   /* I */ .vid_de (hdmi_tx_de), // use tpg: hdmi_tx_de_from_cvo
   /* I */ .vid_hsync (hdmi_tx_hsync), // use tpg: hdmi_tx_hsync_from_cvo
   /* I */ .vid_vsync (hdmi_tx_vsync), // use tpg: hdmi_tx_vsync_from_cvo
	
   /* I */ .Scrambler_Enable (TMDS_Bit_clock_Ratio), 
   /* I */ .TMDS_Bit_clock_Ratio (TMDS_Bit_clock_Ratio),

   /* I */ .tx_hpd_ack (tx_hpd_ack), 
   /* O */ .tx_hpd_req (tx_hpd_req), 
   /* I */ .hdmi_tx_hpd_n (~HDMI_TX_HPD), 
   /* B */ .hdmi_tx_i2c_sda (FMCP_SDA),
   /* B */ .hdmi_tx_i2c_scl (FMCP_SCL),
  
   /* O */ .gxb_tx_cal_busy_out(gxb_tx_cal_busy_out),
   /* I */ .gxb_reconfig_write(gxb_tx_reconfig_write),
   /* I */ .gxb_reconfig_read(gxb_tx_reconfig_read),
   /* I */ .gxb_reconfig_address(gxb_tx_reconfig_address),
   /* I */ .gxb_reconfig_writedata(gxb_tx_reconfig_writedata),
   /* O */ .gxb_reconfig_readdata(gxb_tx_reconfig_readdata),
   /* O */ .gxb_reconfig_waitrequest(gxb_tx_reconfig_waitrequest),
   /* I */ .gxb_tx_cal_busy_in(gxb_tx_cal_busy_in),
   /* I */ .measure_valid_in(measure_valid),
   /* I */ .measure_in(measure),
   /* I */ .measure_valid_ack(tx_measure_valid_ack),
   /* O */ .measure_valid_req(tx_measure_valid_req),
   /* O */ .measure_out(tx_measure)

);





assign {HDMI_TX_D_p[2:0],HDMI_TX_CLK_p} = tx_serial_data;

assign tx_pma_rcfg_mgmt_address = tx_pma_rcfg_mgmt_translator_avalon_anti_slave_address[10:0];


localparam LANES = 4;
localparam DPRIO_ADDRESS_WIDTH = 11;
localparam DPRIO_DATA_WIDTH = 32;
wire [LANES-1:0]                         reconfig_write;
wire [LANES-1:0]                         reconfig_read;
wire [(LANES*DPRIO_ADDRESS_WIDTH)-1:0]   reconfig_address;
wire [(LANES*DPRIO_DATA_WIDTH)-1:0]      reconfig_writedata;

xcvr_reconfig_arbiter #(
    .LANES(LANES),
    .DPRIO_ADDRESS_WIDTH(DPRIO_ADDRESS_WIDTH), 
    .DPRIO_DATA_WIDTH(DPRIO_DATA_WIDTH),
    .EXPIRED_COUNTER(32'h042C1D80)       // 700ms
) u_xcvr_reconfig_arbiter_inst(
    /* I */ .clk(mgmt_clk),            // This should be the same 100MHz clock driving the reconfig controller
    /* I */ .reset(reset),          // This should be the same reset driving the reconfig controller
    /* I */ .rx_rcfg_en(1'b0),
	 
    /* I */ .tx_rcfg_en(tx_reconfig_en), 
    /* I */ .tx_rcfg_ch(tx_pma_ch),
	 
    /* I */ .tx_reconfig_mgmt_write(tx_pma_rcfg_mgmt_write),
    /* I */ .tx_reconfig_mgmt_read(tx_pma_rcfg_mgmt_read),
    /* I */ .tx_reconfig_mgmt_address(tx_pma_rcfg_mgmt_address[10:0]),
    /* I */ .tx_reconfig_mgmt_writedata(tx_pma_rcfg_mgmt_writedata),
    /* O */ .tx_reconfig_mgmt_readdata(tx_pma_rcfg_mgmt_readdata),
    /* O */ .tx_reconfig_mgmt_waitrequest(tx_pma_rcfg_mgmt_waitrequest),
      
    /* O */ .reconfig_write(reconfig_write),
    /* O */ .reconfig_read(reconfig_read),
    /* O */ .reconfig_address(reconfig_address),
    /* O */ .reconfig_writedata(reconfig_writedata),

    /* I */ .tx_reconfig_readdata(gxb_tx_reconfig_readdata),
    /* I */ .tx_reconfig_waitrequest(gxb_tx_reconfig_waitrequest),

    /* I */ .tx_cal_busy(gxb_tx_cal_busy_out),
    /* O */ .tx_reconfig_cal_busy(gxb_tx_cal_busy_in)
);

assign tx_pma_rcfg_mgmt_address = tx_pma_rcfg_mgmt_translator_avalon_anti_slave_address[10:0];

assign gxb_tx_reconfig_write = reconfig_write[3:0];
assign gxb_tx_reconfig_read = reconfig_read[3:0];
assign gxb_tx_reconfig_address = reconfig_address[43:0];
assign gxb_tx_reconfig_writedata = reconfig_writedata[127:0];

        
endmodule



