#define DEBUG_MODE 0

#include <stdio.h>
#include <io.h>
#include <system.h>
#include "xcvr_gpll_rcfg.h"

//
// Functions for Transceiver/PLL Reconfiguration 
//
int GPLL_COMPARE (int PIX_RATE)
{
    int gpll_range;

    if      (PIX_RATE <  500000) gpll_range = 0;
    else if (PIX_RATE < 1000000) gpll_range = 1;
    else if (PIX_RATE < 2000000) gpll_range = 2;
    else if (PIX_RATE < 3000000) gpll_range = 3;
    else if (PIX_RATE < 3400000) gpll_range = 4;
    else if (PIX_RATE < 6000000) gpll_range = 5;

    return gpll_range;
}

int TXPLL_COMPARE (int pix_rate)
{
    int txpll_range;

    if      (pix_rate <=  300000) txpll_range = 0;
    else if (pix_rate <=  350000) txpll_range = 1;
    else if (pix_rate <=  380000) txpll_range = 2;
    else if (pix_rate <=  390000) txpll_range = 3;
    else if (pix_rate <=  500000) txpll_range = 4;
    else if (pix_rate <=  920000) txpll_range = 5;
    else if (pix_rate <= 1000000) txpll_range = 6;
    else if (pix_rate <= 1140000) txpll_range = 7;
    else if (pix_rate <= 1610000) txpll_range = 8;
    else if (pix_rate <= 2270000) txpll_range = 9;
    else if (pix_rate <= 2300000) txpll_range = 10;
    else if (pix_rate <= 3210000) txpll_range = 11;
    else if (pix_rate <= 3400000) txpll_range = 12;
    else if (pix_rate <= 4000000) txpll_range = 13;
    else if (pix_rate <= 4560000) txpll_range = 14;
    else if (pix_rate <= 4600000) txpll_range = 15;
    else if (pix_rate <= 6000000) txpll_range = 16;


   
    return txpll_range;
}

int TX_OS_ENC(int PIX_RATE)
{
  int tx_os;

  if      (PIX_RATE <=  300000)   tx_os = 3;
  else if (PIX_RATE <=  350000)   tx_os = 2;
  else if (PIX_RATE <=  500000)   tx_os = 1;
  else if (PIX_RATE <= 1010000)   tx_os = 3;
  else                            tx_os = 0;

  return tx_os;
}

void RECONFIG_READ_MODIFY_WRITE (int MGMT_ADDR_BASE, int ADDRESS, int BITMASK, int VALUEMASK)
{
  int readdata_reg;
  int data_reg;

  readdata_reg = IORD(MGMT_ADDR_BASE, ADDRESS);
  data_reg = (readdata_reg & ~BITMASK) | (VALUEMASK & BITMASK);
  IOWR (MGMT_ADDR_BASE, ADDRESS, data_reg);
}

//
// PLL Reconfiguration
//
void GPLL_RCFG_WRITE (int OFFSET, int VALUE)
{
  IOWR(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, OFFSET, VALUE);
}

void GPLL_RCFG_RD_MOD_WR (int ADDRESS, int BITMASK, int VALUEMASK)
{
  int readdata_reg;
  int data_reg;

  readdata_reg = IORD(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDRESS);
  data_reg = (readdata_reg & ~BITMASK) | (VALUEMASK & BITMASK);
  IOWR (TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDRESS, data_reg);
}

void READ_GPLL_RCFG_READY ()
{
  //while (IORD(TX_IOPLL_WAITREQUEST_PIO_BASE,0) == 0) {}
  while (IORD(TX_IOPLL_WAITREQUEST_PIO_BASE,0) == 1) {}
}

void GPLL_RECONFIG(int GPLL_RANGE, int COLOR_DEPTH)
{
  //IOWR(WD_TIMER_BASE, 0x0, 0x0); // clear timeout flag
  //IOWR(WD_TIMER_BASE, 0x2, 0x1); // reset internal counter
  //IOWR(WD_TIMER_BASE, 0x1, 0x4); // start timer

  

  int ADDR_BITMASK_VALMASK[16][3];
  int i;
  int NUM_RCFG_WORD = 13;

  // address                          bitmask
  ADDR_BITMASK_VALMASK[0][0] = 0x104; ADDR_BITMASK_VALMASK[0][1] = 0xFF;  //M_HIGH
  ADDR_BITMASK_VALMASK[1][0] = 0x107; ADDR_BITMASK_VALMASK[1][1] = 0xFF;  //M_LOW
  ADDR_BITMASK_VALMASK[2][0] = 0x100; ADDR_BITMASK_VALMASK[2][1] = 0xFF;  //N_HIGH
  ADDR_BITMASK_VALMASK[3][0] = 0x102; ADDR_BITMASK_VALMASK[3][1] = 0xFF;  //N_LOW
  ADDR_BITMASK_VALMASK[4][0] = 0x101; ADDR_BITMASK_VALMASK[4][1] = 0x01;  //N_BYPASS_EN, N_EVEN_DUTY_EN
  ADDR_BITMASK_VALMASK[5][0] = 0x11B; ADDR_BITMASK_VALMASK[5][1] = 0xFF;  //C0_HIGH
  ADDR_BITMASK_VALMASK[6][0] = 0x11E; ADDR_BITMASK_VALMASK[6][1] = 0xFF;  //C0_LOW
  ADDR_BITMASK_VALMASK[7][0] = 0x11F; ADDR_BITMASK_VALMASK[7][1] = 0xFF;  //C1_HIGH
  ADDR_BITMASK_VALMASK[8][0] = 0x122; ADDR_BITMASK_VALMASK[8][1] = 0xFF;  //C1_LOW
  ADDR_BITMASK_VALMASK[9][0] =  0x121; ADDR_BITMASK_VALMASK[9][1] = 0x80;  //C1_EVEN_DUTY_EN
  ADDR_BITMASK_VALMASK[10][0] = 0x101; ADDR_BITMASK_VALMASK[10][1] = 0x70;  //CHARGE_PUMP_CURRENT [2:0]
  ADDR_BITMASK_VALMASK[11][0] = 0x10D; ADDR_BITMASK_VALMASK[11][1] = 0xE0;  //CHARGE_PUMP_CURRENT [5:3]
  ADDR_BITMASK_VALMASK[12][0] = 0x10A; ADDR_BITMASK_VALMASK[12][1] = 0x78;  //BANDWIDTH_CONTROL
  ADDR_BITMASK_VALMASK[13][0] = 0x149; ADDR_BITMASK_VALMASK[13][1] = 0x40; // Request Calibration
  ADDR_BITMASK_VALMASK[14][0] = 0x14A; ADDR_BITMASK_VALMASK[14][1] = 0xFF; // Enable Calibration Interface
  

  if (DEBUG_MODE)
    {
      printf("GPLL_RANGE = %d\n", GPLL_RANGE);
      printf("GPLL RCFG MGMT AFTER RCFG, OFFSET = 0x%x, data = %x\n",ADDR_BITMASK_VALMASK[0][0], IORD(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE,ADDR_BITMASK_VALMASK[0][0]));
      for (i=0; i<NUM_RCFG_WORD; i=i+1) {
      printf("GPLL RCFG MGMT BEFORE RCFG, OFFSET = 0x%x, data = %x\n",ADDR_BITMASK_VALMASK[i][0], IORD(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE,ADDR_BITMASK_VALMASK[i][0]));
      }
      //printf("GPLL RCFG MGMT BEFORE RCFG, OFFSET = 0x4, data = %x\n", IORD(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE,0x4));
      //printf("GPLL RCFG MGMT BEFORE RCFG, OFFSET = 0x8, data = %x\n", IORD(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE,0x8));
      //printf("GPLL RCFG MGMT BEFORE RCFG, OFFSET = 0x9, data = %x\n", IORD(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE,0x9));
      //printf("GPLL RCFG MGMT BEFORE RCFG, OFFSET = 0xA, data = %x\n", IORD(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE,0xA));
      //printf("GPLL RCFG MGMT BEFORE RCFG, OFFSET = 0xB, data = %x\n", IORD(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE,0xB));
      //printf("GPLL RCFG MGMT BEFORE RCFG, OFFSET = 0xC, data = %x\n", IORD(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE,0xC));
    }

  switch (GPLL_RANGE)
  {
    case 0:
      // valmask
      // ROM OFFSET 0 (25MHz - 50MHz)  
      ADDR_BITMASK_VALMASK[0][2] = 0b00001100;        //M_HIGH
      ADDR_BITMASK_VALMASK[1][2] = 0b00001100;        //M_LOW
      ADDR_BITMASK_VALMASK[2][2] = 0b00000000;        //N_HIGH
      ADDR_BITMASK_VALMASK[3][2] = 0b00000000;        //N_LOW
      ADDR_BITMASK_VALMASK[4][2] = 0b01000001;        //N_BYPASS_EN:1, N_EVEN_DUTY_EN:0
      ADDR_BITMASK_VALMASK[5][2] = 0b00011000;        //C0_HIGH:3
      ADDR_BITMASK_VALMASK[6][2] = 0b00011000;        //C0_LOW:3

      if      (COLOR_DEPTH == 0) {
    	  ADDR_BITMASK_VALMASK[7][2] = 0b00011000;        //C1_HIGH
    	  ADDR_BITMASK_VALMASK[8][2] = 0b00011000;        //C1_LOW
    	  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN

      } else if (COLOR_DEPTH == 1) {
    	  ADDR_BITMASK_VALMASK[7][2] = 0b00011110;        //C1_HIGH
    	  ADDR_BITMASK_VALMASK[8][2] = 0b00011110;        //C1_LOW
    	  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN

      } else if (COLOR_DEPTH == 2) {
    	  ADDR_BITMASK_VALMASK[7][2] = 0b00100100;        //C1_HIGH
    	  ADDR_BITMASK_VALMASK[8][2] = 0b00100100;        //C1_LOW
    	  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN
      } else {
    	  ADDR_BITMASK_VALMASK[7][2] = 0b00110000;        //C1_HIGH
    	  ADDR_BITMASK_VALMASK[8][2] = 0b00110000;        //C1_LOW
    	  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN
      }

      ADDR_BITMASK_VALMASK[10][2] = 0b01000001;        //CHARGE_PUMP_CURRENT:8 [2:0]
      ADDR_BITMASK_VALMASK[11][2] = 0b00000000;        //CHARGE_PUMP_CURRENT:8 [5:3]
      ADDR_BITMASK_VALMASK[12][2] = 0b00100000;        //BANDWIDTH_CONTROL:4
      break;

    case 1:
      /// ROM OFFSET 1 (51MHz - 100MHz)
      ADDR_BITMASK_VALMASK[0][2] = 0b00000110;        //M_HIGH:10
      ADDR_BITMASK_VALMASK[1][2] = 0b00000110;        //M_LOW:10
      ADDR_BITMASK_VALMASK[2][2] = 0b00000000;        //N_HIGH:256
      ADDR_BITMASK_VALMASK[3][2] = 0b00000000;        //N_LOW:256
      ADDR_BITMASK_VALMASK[4][2] = 0b01000001;        //N_BYPASS_EN:1, N_EVEN_DUTY_EN:0
      ADDR_BITMASK_VALMASK[5][2] = 0b00001100;        //C0_HIGH:2
      ADDR_BITMASK_VALMASK[6][2] = 0b00001100;        //C0_LOW:2

      if      (COLOR_DEPTH == 0) {
          ADDR_BITMASK_VALMASK[7][2] = 0b00001100;        //C1_HIGH:20
          ADDR_BITMASK_VALMASK[8][2] = 0b00001100;        //C1_LOW:20
          ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN

      } else if (COLOR_DEPTH == 1) {
    	  ADDR_BITMASK_VALMASK[7][2] = 0b00001111;        //C1_HIGH
    	  ADDR_BITMASK_VALMASK[8][2] = 0b00001111;        //C1_LOW
    	  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN

      } else if (COLOR_DEPTH == 2) {
    	  ADDR_BITMASK_VALMASK[7][2] = 0b00010010;        //C1_HIGH
    	  ADDR_BITMASK_VALMASK[8][2] = 0b00010010;        //C1_LOW
    	  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN
      } else {
    	  ADDR_BITMASK_VALMASK[7][2] = 0b00011000;        //C1_HIGH
    	  ADDR_BITMASK_VALMASK[8][2] = 0b00011000;        //C1_LOW
    	  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN
      }

      ADDR_BITMASK_VALMASK[10][2] = 0b01000001;        //CHARGE_PUMP_CURRENT:8 [2:0]
      ADDR_BITMASK_VALMASK[11][2] = 0b00000000;        //CHARGE_PUMP_CURRENT:8 [5:3]
      ADDR_BITMASK_VALMASK[12][2] = 0b00011000;        //BANDWIDTH_CONTROL:4
      break;

    case 2:
    	// ROM OFFSET 2 (101MHz - 200MHz)
      ADDR_BITMASK_VALMASK[0][2] = 0b00000011;        //M_HIGH:5
      ADDR_BITMASK_VALMASK[1][2] = 0b00000011;        //M_LOW:5
      ADDR_BITMASK_VALMASK[2][2] = 0b00000000;        //N_HIGH:256
      ADDR_BITMASK_VALMASK[3][2] = 0b00000000;        //N_LOW:256
      ADDR_BITMASK_VALMASK[4][2] = 0b01000001;        //N_BYPASS_EN:1, N_EVEN_DUTY_EN:0
      ADDR_BITMASK_VALMASK[5][2] = 0b00000110;        //C0_HIGH:1
      ADDR_BITMASK_VALMASK[6][2] = 0b00000110;        //C0_LOW:1

      if      (COLOR_DEPTH == 0) {
          ADDR_BITMASK_VALMASK[7][2] = 0b00000110;        //C1_HIGH:10
          ADDR_BITMASK_VALMASK[8][2] = 0b00000110;        //C1_LOW:10
          ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN

      } else if (COLOR_DEPTH == 1) {
    	  ADDR_BITMASK_VALMASK[7][2] = 0b00001000;        //C1_HIGH
    	  ADDR_BITMASK_VALMASK[8][2] = 0b00000111;        //C1_LOW
    	  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN

      } else if (COLOR_DEPTH == 2) {
    	  ADDR_BITMASK_VALMASK[7][2] = 0b00001001;        //C1_HIGH
    	  ADDR_BITMASK_VALMASK[8][2] = 0b00001001;        //C1_LOW
    	  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN
      } else {
    	  ADDR_BITMASK_VALMASK[7][2] = 0b00001100;        //C1_HIGH
    	  ADDR_BITMASK_VALMASK[8][2] = 0b00001100;        //C1_LOW
    	  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN
      }

      ADDR_BITMASK_VALMASK[10][2] = 0b01000001;        //CHARGE_PUMP_CURRENT:8 [2:0]
      ADDR_BITMASK_VALMASK[11][2] = 0b00000000;        //CHARGE_PUMP_CURRENT:8 [5:3]
      ADDR_BITMASK_VALMASK[12][2] = 0b00011000;        //BANDWIDTH_CONTROL:3
      break;

    case 3:
    	// ROM OFFSET 3 (201MHz - 300MHz)
      ADDR_BITMASK_VALMASK[0][2] = 0b00000010;        //M_HIGH:4
      ADDR_BITMASK_VALMASK[1][2] = 0b00000010;        //M_LOW:4
      ADDR_BITMASK_VALMASK[2][2] = 0b00000000;        //N_HIGH:256
      ADDR_BITMASK_VALMASK[3][2] = 0b00000000;        //N_LOW:256
      ADDR_BITMASK_VALMASK[4][2] = 0b00110001;        //N_BYPASS_EN:1, N_EVEN_DUTY_EN:0
      ADDR_BITMASK_VALMASK[5][2] = 0b00000100;        //C0_HIGH:4
      ADDR_BITMASK_VALMASK[6][2] = 0b00000100;        //C0_LOW:4


      if      (COLOR_DEPTH == 0) {
          ADDR_BITMASK_VALMASK[7][2] = 0b00000100;        //C1_HIGH:8
          ADDR_BITMASK_VALMASK[8][2] = 0b00000100;        //C1_LOW:8
          ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN

      } else if (COLOR_DEPTH == 1) {
    	  ADDR_BITMASK_VALMASK[7][2] = 0b00000101;        //C1_HIGH
    	  ADDR_BITMASK_VALMASK[8][2] = 0b00000101;        //C1_LOW
    	  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN

      } else if (COLOR_DEPTH == 2) {
    	  ADDR_BITMASK_VALMASK[7][2] = 0b00000110;        //C1_HIGH
    	  ADDR_BITMASK_VALMASK[8][2] = 0b00000110;        //C1_LOW
    	  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN
      } else {
    	  ADDR_BITMASK_VALMASK[7][2] = 0b00001000;        //C1_HIGH
    	  ADDR_BITMASK_VALMASK[8][2] = 0b00001000;        //C1_LOW
    	  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN
      }

      ADDR_BITMASK_VALMASK[10][2] = 0b00110001;        //CHARGE_PUMP_CURRENT:8 [2:0]
      ADDR_BITMASK_VALMASK[11][2] = 0b00000000;        //CHARGE_PUMP_CURRENT:8 [5:3]
      ADDR_BITMASK_VALMASK[12][2] = 0b00011000;        //BANDWIDTH_CONTROL:3
      break;


    case 4:
      // ROM OFFSET 4 (301MHz - 340MHz)
      ADDR_BITMASK_VALMASK[0][2] = 0b00000010;        //M_HIGH:4
      ADDR_BITMASK_VALMASK[1][2] = 0b00000010;        //M_LOW:4
      ADDR_BITMASK_VALMASK[2][2] = 0b00000001;        //N_HIGH:256
      ADDR_BITMASK_VALMASK[3][2] = 0b00000001;        //N_LOW:256
      ADDR_BITMASK_VALMASK[4][2] = 0b00110000;        //N_BYPASS_EN:1, N_EVEN_DUTY_EN:0
      ADDR_BITMASK_VALMASK[5][2] = 0b00000010;        //C0_HIGH:2
      ADDR_BITMASK_VALMASK[6][2] = 0b00000010;        //C0_LOW:2

      if      (COLOR_DEPTH == 0) {
          ADDR_BITMASK_VALMASK[7][2] = 0b00000010;        //C1_HIGH:4
          ADDR_BITMASK_VALMASK[8][2] = 0b00000010;        //C1_LOW:4
          ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN

      } else if (COLOR_DEPTH == 1) {
    	  ADDR_BITMASK_VALMASK[7][2] = 0b00000011;        //C1_HIGH
    	  ADDR_BITMASK_VALMASK[8][2] = 0b00000010;        //C1_LOW
    	  ADDR_BITMASK_VALMASK[9][2] = 0b10000000;        //C1_EVEN_DUTY_EN

      } else if (COLOR_DEPTH == 2) {
    	  ADDR_BITMASK_VALMASK[7][2] = 0b00000011;        //C1_HIGH
    	  ADDR_BITMASK_VALMASK[8][2] = 0b00000011;        //C1_LOW
    	  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN
      } else {
    	  ADDR_BITMASK_VALMASK[7][2] = 0b00000100;        //C1_HIGH
    	  ADDR_BITMASK_VALMASK[8][2] = 0b00000100;        //C1_LOW
    	  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN
      }

      ADDR_BITMASK_VALMASK[10][2] = 0b00110000;        //CHARGE_PUMP_CURRENT:5 [2:0]
      ADDR_BITMASK_VALMASK[11][2] = 0b00000000;        //CHARGE_PUMP_CURRENT:5 [5:3]
      ADDR_BITMASK_VALMASK[12][2] = 0b00011000;        //BANDWIDTH_CONTROL:3
      break;

    case 5:
      // ROM OFFSET 5 (85MHz - 150MHz) - 2.0
      ADDR_BITMASK_VALMASK[0][2] = 0b00000100;        //M_HIGH:4
      ADDR_BITMASK_VALMASK[1][2] = 0b00000100;        //M_LOW:4
      ADDR_BITMASK_VALMASK[2][2] = 0b00000000;        //N_HIGH:256
      ADDR_BITMASK_VALMASK[3][2] = 0b00000000;        //N_LOW:256
      ADDR_BITMASK_VALMASK[4][2] = 0b01110001;        //N_BYPASS_EN:1, N_EVEN_DUTY_EN:0
      ADDR_BITMASK_VALMASK[5][2] = 0b00000010;        //C0_HIGH:4
      ADDR_BITMASK_VALMASK[6][2] = 0b00000010;        //C0_LOW:4

      if      (COLOR_DEPTH == 0) {
          ADDR_BITMASK_VALMASK[7][2] = 0b00000010;        //C1_HIGH:2
          ADDR_BITMASK_VALMASK[8][2] = 0b00000010;        //C1_LOW:2
          ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN

      } else if (COLOR_DEPTH == 1) {
    	  ADDR_BITMASK_VALMASK[7][2] = 0b00000011;        //C1_HIGH
    	  ADDR_BITMASK_VALMASK[8][2] = 0b00000010;        //C1_LOW
    	  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN

      } else if (COLOR_DEPTH == 2) {
    	  ADDR_BITMASK_VALMASK[7][2] = 0b00000011;        //C1_HIGH
    	  ADDR_BITMASK_VALMASK[8][2] = 0b00000011;        //C1_LOW
    	  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN
      } else {
    	  ADDR_BITMASK_VALMASK[7][2] = 0b00000100;        //C1_HIGH
    	  ADDR_BITMASK_VALMASK[8][2] = 0b00000100;        //C1_LOW
    	  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN
      }

      ADDR_BITMASK_VALMASK[10][2] = 0b01110001;        //CHARGE_PUMP_CURRENT:8 [2:0]
      ADDR_BITMASK_VALMASK[11][2] = 0b00000000;        //CHARGE_PUMP_CURRENT:8 [5:3]
      ADDR_BITMASK_VALMASK[12][2] = 0b00011000;        //BANDWIDTH_CONTROL:3
      break;

    default: // <600MHz
      // ROM OFFSET 5 (85MHz - 150MHz) - 2.0
	  ADDR_BITMASK_VALMASK[0][2] = 0b00000100;        //M_HIGH:4
	  ADDR_BITMASK_VALMASK[1][2] = 0b00000100;        //M_LOW:4
	  ADDR_BITMASK_VALMASK[2][2] = 0b00000000;        //N_HIGH:256
	  ADDR_BITMASK_VALMASK[3][2] = 0b00000000;        //N_LOW:256
	  ADDR_BITMASK_VALMASK[4][2] = 0b00000001;        //N_BYPASS_EN:1, N_EVEN_DUTY_EN:0
	  ADDR_BITMASK_VALMASK[5][2] = 0b00000010;        //C0_HIGH:4
	  ADDR_BITMASK_VALMASK[6][2] = 0b00000010;        //C0_LOW:4

	  if      (COLOR_DEPTH == 0) {
		  ADDR_BITMASK_VALMASK[7][2] = 0b00000010;        //C1_HIGH:2
		  ADDR_BITMASK_VALMASK[8][2] = 0b00000010;        //C1_LOW:2
		  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN

	  } else if (COLOR_DEPTH == 1) {
		  ADDR_BITMASK_VALMASK[7][2] = 0b00000011;        //C1_HIGH
		  ADDR_BITMASK_VALMASK[8][2] = 0b00000010;        //C1_LOW
		  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN

	  } else if (COLOR_DEPTH == 2) {
		  ADDR_BITMASK_VALMASK[7][2] = 0b00000011;        //C1_HIGH
		  ADDR_BITMASK_VALMASK[8][2] = 0b00000011;        //C1_LOW
		  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN
	  } else {
		  ADDR_BITMASK_VALMASK[7][2] = 0b00000100;        //C1_HIGH
		  ADDR_BITMASK_VALMASK[8][2] = 0b00000100;        //C1_LOW
		  ADDR_BITMASK_VALMASK[9][2] = 0b00000000;        //C1_EVEN_DUTY_EN
	  }

	  ADDR_BITMASK_VALMASK[10][2] = 0b00000001;        //CHARGE_PUMP_CURRENT:8 [2:0]
	  ADDR_BITMASK_VALMASK[11][2] = 0b00100000;        //CHARGE_PUMP_CURRENT:8 [5:3]
	  ADDR_BITMASK_VALMASK[12][2] = 0b00011000;        //BANDWIDTH_CONTROL:3
      break;
  }
  
    for (i=0; i<NUM_RCFG_WORD; i=i+1)
    {
         int address = ADDR_BITMASK_VALMASK[i][0];
         int bitmask = ADDR_BITMASK_VALMASK[i][1];
         int valmask = ADDR_BITMASK_VALMASK[i][2];
         RECONFIG_READ_MODIFY_WRITE (TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, address, bitmask, valmask);
    }

    //RECONFIG_READ_MODIFY_WRITE(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[0][0], ADDR_BITMASK_VALMASK[0][1],ADDR_BITMASK_VALMASK[0][2]);
      //RECONFIG_READ_MODIFY_WRITE(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[1][0], ADDR_BITMASK_VALMASK[1][1],ADDR_BITMASK_VALMASK[1][2]);
      //RECONFIG_READ_MODIFY_WRITE(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[2][0], ADDR_BITMASK_VALMASK[2][1],ADDR_BITMASK_VALMASK[2][2]);
      //RECONFIG_READ_MODIFY_WRITE(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[3][0], ADDR_BITMASK_VALMASK[3][1],ADDR_BITMASK_VALMASK[3][2]);
      //RECONFIG_READ_MODIFY_WRITE(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[4][0], ADDR_BITMASK_VALMASK[4][1],ADDR_BITMASK_VALMASK[4][2]);
      //RECONFIG_READ_MODIFY_WRITE(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[5][0], ADDR_BITMASK_VALMASK[5][1],ADDR_BITMASK_VALMASK[5][2]);
      //RECONFIG_READ_MODIFY_WRITE(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[6][0], ADDR_BITMASK_VALMASK[6][1],ADDR_BITMASK_VALMASK[6][2]);
      //RECONFIG_READ_MODIFY_WRITE(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[7][0], ADDR_BITMASK_VALMASK[7][1],ADDR_BITMASK_VALMASK[7][2]);
      //RECONFIG_READ_MODIFY_WRITE(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[8][0], ADDR_BITMASK_VALMASK[8][1],ADDR_BITMASK_VALMASK[8][2]);
      //RECONFIG_READ_MODIFY_WRITE(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[9][0], ADDR_BITMASK_VALMASK[9][1],ADDR_BITMASK_VALMASK[9][2]);
      //RECONFIG_READ_MODIFY_WRITE(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[10][0], ADDR_BITMASK_VALMASK[10][1],ADDR_BITMASK_VALMASK[10][2]);
      //RECONFIG_READ_MODIFY_WRITE(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[11][0], ADDR_BITMASK_VALMASK[11][1],ADDR_BITMASK_VALMASK[11][2]);
      //RECONFIG_READ_MODIFY_WRITE(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[12][0], ADDR_BITMASK_VALMASK[12][1],ADDR_BITMASK_VALMASK[12][2]);
      //RECONFIG_READ_MODIFY_WRITE(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[13][0], ADDR_BITMASK_VALMASK[13][1],ADDR_BITMASK_VALMASK[13][2]);
  //IOWR(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[0][0],ADDR_BITMASK_VALMASK[0][2]);
        //IOWR(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[0][0],ADDR_BITMASK_VALMASK[0][2]);
        //IOWR(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[1][0],ADDR_BITMASK_VALMASK[1][2]);
        //IOWR(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[2][0],ADDR_BITMASK_VALMASK[2][2]);
        //IOWR(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[3][0],ADDR_BITMASK_VALMASK[3][2]);
        //IOWR(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[4][0],ADDR_BITMASK_VALMASK[4][2]);
        //IOWR(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[5][0],ADDR_BITMASK_VALMASK[5][2]);
        //IOWR(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[6][0],ADDR_BITMASK_VALMASK[6][2]);
        //IOWR(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[7][0],ADDR_BITMASK_VALMASK[7][2]);
        //IOWR(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[8][0],ADDR_BITMASK_VALMASK[8][2]);
        //IOWR(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[9][0],ADDR_BITMASK_VALMASK[9][2]);
        //IOWR(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[10][0],ADDR_BITMASK_VALMASK[10][2]);
        //IOWR(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[11][0],ADDR_BITMASK_VALMASK[11][2]);
        //IOWR(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[12][0],ADDR_BITMASK_VALMASK[12][2]);
       // IOWR(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[13][0],ADDR_BITMASK_VALMASK[13][2]);
      //IOWR(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[11][0],0x1);
      //IOWR(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[12][0],0x28);


     RECONFIG_READ_MODIFY_WRITE (TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE, ADDR_BITMASK_VALMASK[13][0], 0x40, 0x40);
     
     GPLL_RCFG_WRITE (ADDR_BITMASK_VALMASK[14][0], 0x03);


    READ_GPLL_RCFG_READY ();

    if (DEBUG_MODE) printf("\n After IOPLL Reconfiguration\n");
    if (DEBUG_MODE) printf("GPLL RCFG MGMT AFTER RCFG, OFFSET = 0x%x, data = %x\n",ADDR_BITMASK_VALMASK[0][0], IORD(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE,ADDR_BITMASK_VALMASK[0][0]));
    for (i=0; i<NUM_RCFG_WORD; i=i+1) {
    	if (DEBUG_MODE) printf("GPLL RCFG MGMT AFTER RCFG, OFFSET = 0x%x, data = %x\n",ADDR_BITMASK_VALMASK[i][0], IORD(TX_IOPLL_RCFG_MGMT_TRANSLATOR_BASE,ADDR_BITMASK_VALMASK[i][0]));
	  }

    //IOWR(WD_TIMER_BASE, 0x1, 0x8); // stop the timer
    //IOWR(WD_TIMER_BASE, 0x0, 0x0); // clear timeout flag
    //IOWR(WD_TIMER_BASE, 0x2, 0x1); // reset internal counter
}

//
// Transceiver Reconfiguration
//
void READ_XCVR_RCFG_BUSY (int MGMT_ADDR_BASE)
{
  while ((IORD(MGMT_ADDR_BASE,0) && 0x01) == 0) {};
  while ((IORD(MGMT_ADDR_BASE,0) && 0x01) == 1) {};
}

void READ_PLL_RECAL_DONE ()
{
  int recal_done_reg;

  do
  {
	  recal_done_reg = IORD(TX_PLL_RCFG_MGMT_TRANSLATOR_BASE, 0x000);
  }
  while ((recal_done_reg >> 1 & 0x01) == 0);

}

void WAIT_TXPMA_BUSY ()
{
  int txpma_waitrequest;

  do
  {
	  txpma_waitrequest = IORD(TX_PMA_WAITREQUEST_PIO_BASE, 0x000);
  }
  while ((txpma_waitrequest & 0x01) == 1);

}



void TX_PLL_RECONFIG (int TXPLL_RANGE)
{
  int ADDR_BITMASK_VALMASK[9][3];
  int i;
  int NUM_RCFG_WORD = 9;

  NUM_RCFG_WORD = 9;
  // address                          bitmask
  ADDR_BITMASK_VALMASK[0][0] = 0x10A; ADDR_BITMASK_VALMASK[0][1] = 0xFF;
  ADDR_BITMASK_VALMASK[1][0] = 0x123; ADDR_BITMASK_VALMASK[1][1] = 0x3F;
  ADDR_BITMASK_VALMASK[2][0] = 0x12B; ADDR_BITMASK_VALMASK[2][1] = 0xFF;
  ADDR_BITMASK_VALMASK[3][0] = 0x12C; ADDR_BITMASK_VALMASK[3][1] = 0xFF;
  ADDR_BITMASK_VALMASK[4][0] = 0x133; ADDR_BITMASK_VALMASK[4][1] = 0x7F;
  ADDR_BITMASK_VALMASK[5][0] = 0x134; ADDR_BITMASK_VALMASK[5][1] = 0x7C;
  ADDR_BITMASK_VALMASK[6][0] = 0x135; ADDR_BITMASK_VALMASK[6][1] = 0xFF;
  ADDR_BITMASK_VALMASK[7][0] = 0x136; ADDR_BITMASK_VALMASK[7][1] = 0xFF;
  ADDR_BITMASK_VALMASK[8][0] = 0x142; ADDR_BITMASK_VALMASK[8][1] = 0xFF;
         
  switch (TXPLL_RANGE)
  {
    case 0: // 30MHz, HDMI 1.4
      // valmask
      ADDR_BITMASK_VALMASK[0][2] = 0xE2;
      ADDR_BITMASK_VALMASK[1][2] = 0x22;
      ADDR_BITMASK_VALMASK[2][2] = 0x64;
      ADDR_BITMASK_VALMASK[3][2] = 0x0C;
      ADDR_BITMASK_VALMASK[4][2] = 0x4E;
      ADDR_BITMASK_VALMASK[5][2] = 0x10;
      ADDR_BITMASK_VALMASK[6][2] = 0x03;
      ADDR_BITMASK_VALMASK[7][2] = 0x21;
      ADDR_BITMASK_VALMASK[8][2] = 0x00;
      break;
      
    case 1: // 35MHz, HDMI 1.4
      // valmask
      ADDR_BITMASK_VALMASK[0][2] = 0xE2;
      ADDR_BITMASK_VALMASK[1][2] = 0x22;
      ADDR_BITMASK_VALMASK[2][2] = 0x50;
      ADDR_BITMASK_VALMASK[3][2] = 0x0C;
      ADDR_BITMASK_VALMASK[4][2] = 0x4E;
      ADDR_BITMASK_VALMASK[5][2] = 0x10;
      ADDR_BITMASK_VALMASK[6][2] = 0x03;
      ADDR_BITMASK_VALMASK[7][2] = 0x21;
      ADDR_BITMASK_VALMASK[8][2] = 0x00;
      break;
      
    case 2: // 37MHz, HDMI 1.4
      // valmask
      ADDR_BITMASK_VALMASK[0][2] = 0xE2;
      ADDR_BITMASK_VALMASK[1][2] = 0x22;
      ADDR_BITMASK_VALMASK[2][2] = 0x78;
      ADDR_BITMASK_VALMASK[3][2] = 0x0E;
      ADDR_BITMASK_VALMASK[4][2] = 0x4E;
      ADDR_BITMASK_VALMASK[5][2] = 0x10;
      ADDR_BITMASK_VALMASK[6][2] = 0x03;
      ADDR_BITMASK_VALMASK[7][2] = 0x21;
      ADDR_BITMASK_VALMASK[8][2] = 0x00;
      break;
      
    case 3: // 38MHz, HDMI 1.4
      // valmask
      ADDR_BITMASK_VALMASK[0][2] = 0xF4;
      ADDR_BITMASK_VALMASK[1][2] = 0x34;
      ADDR_BITMASK_VALMASK[2][2] = 0x78;
      ADDR_BITMASK_VALMASK[3][2] = 0x0E;
      ADDR_BITMASK_VALMASK[4][2] = 0x4E;
      ADDR_BITMASK_VALMASK[5][2] = 0x10;
      ADDR_BITMASK_VALMASK[6][2] = 0x03;
      ADDR_BITMASK_VALMASK[7][2] = 0x21;
      ADDR_BITMASK_VALMASK[8][2] = 0x00;
      break;
      
    case 4: // 50MHz, HDMI 1.4
      // valmask
      ADDR_BITMASK_VALMASK[0][2] = 0xE2;
      ADDR_BITMASK_VALMASK[1][2] = 0x22;
      ADDR_BITMASK_VALMASK[2][2] = 0x3C;
      ADDR_BITMASK_VALMASK[3][2] = 0x0C;
      ADDR_BITMASK_VALMASK[4][2] = 0x46;
      ADDR_BITMASK_VALMASK[5][2] = 0x10;
      ADDR_BITMASK_VALMASK[6][2] = 0x03;
      ADDR_BITMASK_VALMASK[7][2] = 0x21;
      ADDR_BITMASK_VALMASK[8][2] = 0x00;
      break;
      
    case 5: // 92MHz, HDMI 1.4
      // valmask
      ADDR_BITMASK_VALMASK[0][2] = 0xE2;
      ADDR_BITMASK_VALMASK[1][2] = 0x22;
      ADDR_BITMASK_VALMASK[2][2] = 0x32;
      ADDR_BITMASK_VALMASK[3][2] = 0x0A;
      ADDR_BITMASK_VALMASK[4][2] = 0x42;
      ADDR_BITMASK_VALMASK[5][2] = 0x30;
      ADDR_BITMASK_VALMASK[6][2] = 0x03;
      ADDR_BITMASK_VALMASK[7][2] = 0x21;
      ADDR_BITMASK_VALMASK[8][2] = 0x00;
      break;
    
    case 6: // 100MHz, HDMI 1.4
      // valmask
      ADDR_BITMASK_VALMASK[0][2] = 0xE2;
      ADDR_BITMASK_VALMASK[1][2] = 0x22;
      ADDR_BITMASK_VALMASK[2][2] = 0x19;
      ADDR_BITMASK_VALMASK[3][2] = 0x08;
      ADDR_BITMASK_VALMASK[4][2] = 0x42;
      ADDR_BITMASK_VALMASK[5][2] = 0x10;
      ADDR_BITMASK_VALMASK[6][2] = 0x03;
      ADDR_BITMASK_VALMASK[7][2] = 0x25;
      ADDR_BITMASK_VALMASK[8][2] = 0x30;
      break;
      
    case 7: // 114Hz, HDMI 1.4
      // valmask
      ADDR_BITMASK_VALMASK[0][2] = 0xE2;
      ADDR_BITMASK_VALMASK[1][2] = 0x22;
      ADDR_BITMASK_VALMASK[2][2] = 0x28;
      ADDR_BITMASK_VALMASK[3][2] = 0x0E;
      ADDR_BITMASK_VALMASK[4][2] = 0x46;
      ADDR_BITMASK_VALMASK[5][2] = 0x10;
      ADDR_BITMASK_VALMASK[6][2] = 0x03;
      ADDR_BITMASK_VALMASK[7][2] = 0x21;
      ADDR_BITMASK_VALMASK[8][2] = 0x00;
      break;
      
    case 8: // 161MHz, HDMI 1.4
      // valmask
      ADDR_BITMASK_VALMASK[0][2] = 0xE2;
      ADDR_BITMASK_VALMASK[1][2] = 0x22;
      ADDR_BITMASK_VALMASK[2][2] = 0x14;
      ADDR_BITMASK_VALMASK[3][2] = 0x0C;
      ADDR_BITMASK_VALMASK[4][2] = 0x42;
      ADDR_BITMASK_VALMASK[5][2] = 0x10;
      ADDR_BITMASK_VALMASK[6][2] = 0x03;
      ADDR_BITMASK_VALMASK[7][2] = 0x21;
      ADDR_BITMASK_VALMASK[8][2] = 0x00;
      break;

    case 9: // 227MHz, HDMI 1.4
      // valmask
      ADDR_BITMASK_VALMASK[0][2] = 0xE2;
      ADDR_BITMASK_VALMASK[1][2] = 0x22;
      ADDR_BITMASK_VALMASK[2][2] = 0x28;
      ADDR_BITMASK_VALMASK[3][2] = 0x14;
      ADDR_BITMASK_VALMASK[4][2] = 0x46;
      ADDR_BITMASK_VALMASK[5][2] = 0x10;
      ADDR_BITMASK_VALMASK[6][2] = 0x03;
      ADDR_BITMASK_VALMASK[7][2] = 0x21;
      ADDR_BITMASK_VALMASK[8][2] = 0x00;
      break;

    case 10: // 230MHz, HDMI 1.4
      // valmask
      ADDR_BITMASK_VALMASK[0][2] = 0xF4;
      ADDR_BITMASK_VALMASK[1][2] = 0x34;
      ADDR_BITMASK_VALMASK[2][2] = 0x28;
      ADDR_BITMASK_VALMASK[3][2] = 0x14;
      ADDR_BITMASK_VALMASK[4][2] = 0x46;
      ADDR_BITMASK_VALMASK[5][2] = 0x10;
      ADDR_BITMASK_VALMASK[6][2] = 0x03;
      ADDR_BITMASK_VALMASK[7][2] = 0x21;
      ADDR_BITMASK_VALMASK[8][2] = 0x00;
      break;


    case 11: // 321MHz, HDMI 1.4
      // valmask
      ADDR_BITMASK_VALMASK[0][2] = 0xE2;
      ADDR_BITMASK_VALMASK[1][2] = 0x22;
      ADDR_BITMASK_VALMASK[2][2] = 0x14;
      ADDR_BITMASK_VALMASK[3][2] = 0x12;
      ADDR_BITMASK_VALMASK[4][2] = 0x42;
      ADDR_BITMASK_VALMASK[5][2] = 0x10;
      ADDR_BITMASK_VALMASK[6][2] = 0x03;
      ADDR_BITMASK_VALMASK[7][2] = 0x21;
      ADDR_BITMASK_VALMASK[8][2] = 0x00;
      break;

    case 12: // 340MHz, HDMI 1.4b
      // valmask
      ADDR_BITMASK_VALMASK[0][2] = 0xE2;
      ADDR_BITMASK_VALMASK[1][2] = 0x22;
      ADDR_BITMASK_VALMASK[2][2] = 0x1E;
      ADDR_BITMASK_VALMASK[3][2] = 0x1A;
      ADDR_BITMASK_VALMASK[4][2] = 0x42;
      ADDR_BITMASK_VALMASK[5][2] = 0x10;
      ADDR_BITMASK_VALMASK[6][2] = 0x03;
      ADDR_BITMASK_VALMASK[7][2] = 0x21;
      ADDR_BITMASK_VALMASK[8][2] = 0x00;
      break;

    case 13: // 400MHz, HDMI 2.0
      // valmask
      ADDR_BITMASK_VALMASK[0][2] = 0xE2;
      ADDR_BITMASK_VALMASK[1][2] = 0x22;
      ADDR_BITMASK_VALMASK[2][2] = 0x28;
      ADDR_BITMASK_VALMASK[3][2] = 0x0A;
      ADDR_BITMASK_VALMASK[4][2] = 0x46;
      ADDR_BITMASK_VALMASK[5][2] = 0x10;
      ADDR_BITMASK_VALMASK[6][2] = 0x03;
      ADDR_BITMASK_VALMASK[7][2] = 0x21;
      ADDR_BITMASK_VALMASK[8][2] = 0x00;
      break;
        
    case 14: // 456MHz, HDMI 2.0
      // valmask
      ADDR_BITMASK_VALMASK[0][2] = 0xE2;
      ADDR_BITMASK_VALMASK[1][2] = 0x22;
      ADDR_BITMASK_VALMASK[2][2] = 0x28;
      ADDR_BITMASK_VALMASK[3][2] = 0x0A;
      ADDR_BITMASK_VALMASK[4][2] = 0x46;
      ADDR_BITMASK_VALMASK[5][2] = 0x10;
      ADDR_BITMASK_VALMASK[6][2] = 0x03;
      ADDR_BITMASK_VALMASK[7][2] = 0x21;
      ADDR_BITMASK_VALMASK[8][2] = 0x30;
      break;

    case 15: // 460MHz, HDMI 2.0
      // valmask
      ADDR_BITMASK_VALMASK[0][2] = 0xF4;
      ADDR_BITMASK_VALMASK[1][2] = 0x34;
      ADDR_BITMASK_VALMASK[2][2] = 0x28;
      ADDR_BITMASK_VALMASK[3][2] = 0x0A;
      ADDR_BITMASK_VALMASK[4][2] = 0x46;
      ADDR_BITMASK_VALMASK[5][2] = 0x10;
      ADDR_BITMASK_VALMASK[6][2] = 0x03;
      ADDR_BITMASK_VALMASK[7][2] = 0x21;
      ADDR_BITMASK_VALMASK[8][2] = 0x00;
      break;

    case 16: // 600MHz, HDMI 2.0
      // valmask
      ADDR_BITMASK_VALMASK[0][2] = 0xE2;
      ADDR_BITMASK_VALMASK[1][2] = 0x22;
      ADDR_BITMASK_VALMASK[2][2] = 0x14;
      ADDR_BITMASK_VALMASK[3][2] = 0x08;
      ADDR_BITMASK_VALMASK[4][2] = 0x42;
      ADDR_BITMASK_VALMASK[5][2] = 0x10;
      ADDR_BITMASK_VALMASK[6][2] = 0x03;
      ADDR_BITMASK_VALMASK[7][2] = 0x25;
      ADDR_BITMASK_VALMASK[8][2] = 0x00;
      break;

    default: // <600MHz
      // valmask
      ADDR_BITMASK_VALMASK[0][2] = 0xE2;
      ADDR_BITMASK_VALMASK[1][2] = 0x22;
      ADDR_BITMASK_VALMASK[2][2] = 0x14;
      ADDR_BITMASK_VALMASK[3][2] = 0x08;
      ADDR_BITMASK_VALMASK[4][2] = 0x42;
      ADDR_BITMASK_VALMASK[5][2] = 0x10;
      ADDR_BITMASK_VALMASK[6][2] = 0x03;
      ADDR_BITMASK_VALMASK[7][2] = 0x25;
      ADDR_BITMASK_VALMASK[8][2] = 0x00;
      break;
  }
  


   IOWR (TX_PLL_RCFG_MGMT_TRANSLATOR_BASE, 0x000, 0x00000002); // Request user access to the internal configuration bus of TX PLL

   RECONFIG_READ_MODIFY_WRITE (TX_PLL_RCFG_MGMT_TRANSLATOR_BASE, 0x100 , 0x01, 0x01); // Write pre_reconfig bit of fpll 0x100[0]
   
   IOWR (TX_PLL_RCFG_MGMT_TRANSLATOR_BASE, 0x000, 0x00000001); // release user access

   READ_PLL_RECAL_DONE(); //Wait for FPLL calibration busy goes low

   IOWR (TX_PLL_RCFG_MGMT_TRANSLATOR_BASE, 0x000, 0x00000002); // Request user access to the internal configuration bus of TX PLL


  for (i=0; i<NUM_RCFG_WORD; i=i+1)
  {
       int address = ADDR_BITMASK_VALMASK[i][0];
       int bitmask = ADDR_BITMASK_VALMASK[i][1];
       int valmask = ADDR_BITMASK_VALMASK[i][2];
       RECONFIG_READ_MODIFY_WRITE (TX_PLL_RCFG_MGMT_TRANSLATOR_BASE, address, bitmask, valmask);
   }

  RECONFIG_READ_MODIFY_WRITE (TX_PLL_RCFG_MGMT_TRANSLATOR_BASE, 0x100, 0x02, 0x02); // FPLL recalibration

  IOWR (TX_PLL_RCFG_MGMT_TRANSLATOR_BASE, 0x000, 0x00000001); // release user access

  READ_PLL_RECAL_DONE(); //Wait for FPLL calibration busy goes low

  // TX PMA Recalibration
  IOWR(TX_RCFG_EN_PIO_BASE, 0, 1); //Assert the tx_reconfig_en in the XCVR Arbiter

  for (int CH=0; CH <4; CH++ ) {
    
    if(DEBUG_MODE) printf("Calibrating TX PMA Channel %d\n", CH);

    IOWR(TX_PMA_CH_BASE, 0, CH);

    IOWR (TX_PMA_RCFG_MGMT_TRANSLATOR_BASE, 0x000, 0x00000002); // Request user access to the internal configuration bus of TX PMA

    WAIT_TXPMA_BUSY(); // Wait reconfig_waitrequest is low, access granted
	
    RECONFIG_READ_MODIFY_WRITE(TX_PMA_RCFG_MGMT_TRANSLATOR_BASE, 0x100, 0x02 ,0x02); //set 0x100[1] to 1 for TX PMA calibration

    IOWR (TX_PMA_RCFG_MGMT_TRANSLATOR_BASE, 0x000, 0x00000001); // release user access

    READ_XCVR_RCFG_BUSY(TX_PMA_CAL_BUSY_PIO_BASE); // Wait for TX PMA Calibration Busy for all channels to be deasserted

  }
  
  if(DEBUG_MODE) printf("TX PMA Calibration Done\n");
  
  IOWR(TX_RCFG_EN_PIO_BASE, 0, 0); //De-assert the tx_reconfig_en in the XCVR Arbiter

}
