// gxb_rx_reset.v

// Generated using ACDS version 20.2 50

`timescale 1 ps / 1 ps
module gxb_rx_reset (
		input  wire       clock,                //                clock.clk
		input  wire       reset,                //                reset.reset
		output wire [2:0] rx_analogreset,       //       rx_analogreset.rx_analogreset
		output wire [2:0] rx_digitalreset,      //      rx_digitalreset.rx_digitalreset
		output wire [2:0] rx_ready,             //             rx_ready.rx_ready
		input  wire [2:0] rx_is_lockedtodata,   //   rx_is_lockedtodata.rx_is_lockedtodata
		input  wire [2:0] rx_cal_busy,          //          rx_cal_busy.rx_cal_busy
		input  wire [2:0] rx_analogreset_stat,  //  rx_analogreset_stat.rx_analogreset_stat
		input  wire [2:0] rx_digitalreset_stat  // rx_digitalreset_stat.rx_digitalreset_stat
	);

	altera_xcvr_reset_control_s10 #(
		.CHANNELS           (3),
		.PLLS               (1),
		.SYS_CLK_IN_MHZ     (100),
		.REDUCED_SIM_TIME   (1),
		.ENABLE_DIGITAL_SEQ (0),
		.TX_PLL_ENABLE      (0),
		.T_PLL_POWERDOWN    (1000),
		.TX_ENABLE          (0),
		.TX_PER_CHANNEL     (0),
		.TX_MANUAL_RESET    (0),
		.T_TX_ANALOGRESET   (0),
		.T_TX_DIGITALRESET  (20),
		.T_PLL_LOCK_HYST    (0),
		.EN_PLL_CAL_BUSY    (0),
		.RX_ENABLE          (1),
		.RX_PER_CHANNEL     (1),
		.RX_MANUAL_RESET    (0),
		.T_RX_ANALOGRESET   (70000),
		.T_RX_DIGITALRESET  (5000)
	) gxb_rx_reset (
		.clock                (clock),                //   input,  width = 1,                clock.clk
		.reset                (reset),                //   input,  width = 1,                reset.reset
		.rx_analogreset       (rx_analogreset),       //  output,  width = 3,       rx_analogreset.rx_analogreset
		.rx_digitalreset      (rx_digitalreset),      //  output,  width = 3,      rx_digitalreset.rx_digitalreset
		.rx_ready             (rx_ready),             //  output,  width = 3,             rx_ready.rx_ready
		.rx_is_lockedtodata   (rx_is_lockedtodata),   //   input,  width = 3,   rx_is_lockedtodata.rx_is_lockedtodata
		.rx_cal_busy          (rx_cal_busy),          //   input,  width = 3,          rx_cal_busy.rx_cal_busy
		.rx_analogreset_stat  (rx_analogreset_stat),  //   input,  width = 3,  rx_analogreset_stat.rx_analogreset_stat
		.rx_digitalreset_stat (rx_digitalreset_stat), //   input,  width = 3, rx_digitalreset_stat.rx_digitalreset_stat
		.pll_powerdown        (),                     // (terminated),                                  
		.tx_analogreset       (),                     // (terminated),                                  
		.tx_digitalreset      (),                     // (terminated),                                  
		.tx_ready             (),                     // (terminated),                                  
		.pll_locked           (1'b0),                 // (terminated),                                  
		.pll_select           (1'b0),                 // (terminated),                                  
		.tx_cal_busy          (3'b000),               // (terminated),                                  
		.tx_analogreset_stat  (3'b000),               // (terminated),                                  
		.tx_digitalreset_stat (3'b000),               // (terminated),                                  
		.pll_cal_busy         (1'b0),                 // (terminated),                                  
		.tx_digitalreset_or   (3'b000),               // (terminated),                                  
		.rx_digitalreset_or   (3'b000)                // (terminated),                                  
	);

endmodule
