	component gxb_tx is
		port (
			tx_analogreset          : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- tx_analogreset
			tx_digitalreset         : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- tx_digitalreset
			tx_analogreset_stat     : out std_logic_vector(3 downto 0);                      -- tx_analogreset_stat
			tx_digitalreset_stat    : out std_logic_vector(3 downto 0);                      -- tx_digitalreset_stat
			tx_cal_busy             : out std_logic_vector(3 downto 0);                      -- tx_cal_busy
			tx_bonding_clocks       : in  std_logic_vector(23 downto 0)  := (others => 'X'); -- clk
			tx_serial_data          : out std_logic_vector(3 downto 0);                      -- tx_serial_data
			tx_coreclkin            : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- clk
			tx_clkout               : out std_logic_vector(3 downto 0);                      -- clk
			tx_clkout2              : out std_logic_vector(3 downto 0);                      -- clk
			tx_parallel_data        : in  std_logic_vector(79 downto 0)  := (others => 'X'); -- tx_parallel_data
			unused_tx_parallel_data : in  std_logic_vector(239 downto 0) := (others => 'X'); -- unused_tx_parallel_data
			tx_polinv               : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- tx_polinv
			reconfig_clk            : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- clk
			reconfig_reset          : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- reset
			reconfig_write          : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- write
			reconfig_read           : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- read
			reconfig_address        : in  std_logic_vector(43 downto 0)  := (others => 'X'); -- address
			reconfig_writedata      : in  std_logic_vector(127 downto 0) := (others => 'X'); -- writedata
			reconfig_readdata       : out std_logic_vector(127 downto 0);                    -- readdata
			reconfig_waitrequest    : out std_logic_vector(3 downto 0)                       -- waitrequest
		);
	end component gxb_tx;

	u0 : component gxb_tx
		port map (
			tx_analogreset          => CONNECTED_TO_tx_analogreset,          --          tx_analogreset.tx_analogreset
			tx_digitalreset         => CONNECTED_TO_tx_digitalreset,         --         tx_digitalreset.tx_digitalreset
			tx_analogreset_stat     => CONNECTED_TO_tx_analogreset_stat,     --     tx_analogreset_stat.tx_analogreset_stat
			tx_digitalreset_stat    => CONNECTED_TO_tx_digitalreset_stat,    --    tx_digitalreset_stat.tx_digitalreset_stat
			tx_cal_busy             => CONNECTED_TO_tx_cal_busy,             --             tx_cal_busy.tx_cal_busy
			tx_bonding_clocks       => CONNECTED_TO_tx_bonding_clocks,       --       tx_bonding_clocks.clk
			tx_serial_data          => CONNECTED_TO_tx_serial_data,          --          tx_serial_data.tx_serial_data
			tx_coreclkin            => CONNECTED_TO_tx_coreclkin,            --            tx_coreclkin.clk
			tx_clkout               => CONNECTED_TO_tx_clkout,               --               tx_clkout.clk
			tx_clkout2              => CONNECTED_TO_tx_clkout2,              --              tx_clkout2.clk
			tx_parallel_data        => CONNECTED_TO_tx_parallel_data,        --        tx_parallel_data.tx_parallel_data
			unused_tx_parallel_data => CONNECTED_TO_unused_tx_parallel_data, -- unused_tx_parallel_data.unused_tx_parallel_data
			tx_polinv               => CONNECTED_TO_tx_polinv,               --               tx_polinv.tx_polinv
			reconfig_clk            => CONNECTED_TO_reconfig_clk,            --            reconfig_clk.clk
			reconfig_reset          => CONNECTED_TO_reconfig_reset,          --          reconfig_reset.reset
			reconfig_write          => CONNECTED_TO_reconfig_write,          --           reconfig_avmm.write
			reconfig_read           => CONNECTED_TO_reconfig_read,           --                        .read
			reconfig_address        => CONNECTED_TO_reconfig_address,        --                        .address
			reconfig_writedata      => CONNECTED_TO_reconfig_writedata,      --                        .writedata
			reconfig_readdata       => CONNECTED_TO_reconfig_readdata,       --                        .readdata
			reconfig_waitrequest    => CONNECTED_TO_reconfig_waitrequest     --                        .waitrequest
		);

