	component hdmi_rx is
		port (
			reset                : in  std_logic                      := 'X';             -- export
			reset_vid            : in  std_logic                      := 'X';             -- export
			vid_clk              : in  std_logic                      := 'X';             -- export
			ls_clk               : in  std_logic                      := 'X';             -- export
			locked               : out std_logic;                                         -- export
			mode                 : out std_logic;                                         -- export
			ctrl                 : out std_logic_vector(11 downto 0);                     -- export
			vid_lock             : out std_logic;                                         -- export
			vid_de               : out std_logic_vector(1 downto 0);                      -- export
			vid_data             : out std_logic_vector(95 downto 0);                     -- export
			vid_hsync            : out std_logic_vector(1 downto 0);                      -- export
			vid_vsync            : out std_logic_vector(1 downto 0);                      -- export
			in_b                 : in  std_logic_vector(19 downto 0)  := (others => 'X'); -- export
			in_r                 : in  std_logic_vector(19 downto 0)  := (others => 'X'); -- export
			in_g                 : in  std_logic_vector(19 downto 0)  := (others => 'X'); -- export
			in_lock              : in  std_logic                      := 'X';             -- export
			aux_valid            : out std_logic;                                         -- export
			aux_data             : out std_logic_vector(71 downto 0);                     -- export
			aux_sop              : out std_logic;                                         -- export
			aux_eop              : out std_logic;                                         -- export
			aux_error            : out std_logic;                                         -- export
			gcp                  : out std_logic_vector(5 downto 0);                      -- export
			info_avi             : out std_logic_vector(111 downto 0);                    -- export
			info_vsi             : out std_logic_vector(60 downto 0);                     -- export
			aux_pkt_addr         : out std_logic_vector(6 downto 0);                      -- export
			aux_pkt_data         : out std_logic_vector(71 downto 0);                     -- export
			aux_pkt_wr           : out std_logic;                                         -- export
			audio_CTS            : out std_logic_vector(19 downto 0);                     -- export
			audio_N              : out std_logic_vector(19 downto 0);                     -- export
			audio_data           : out std_logic_vector(255 downto 0);                    -- export
			audio_de             : out std_logic;                                         -- export
			audio_info_ai        : out std_logic_vector(47 downto 0);                     -- export
			audio_metadata       : out std_logic_vector(164 downto 0);                    -- export
			audio_format         : out std_logic_vector(4 downto 0);                      -- export
			scdc_i2c_clk         : in  std_logic                      := 'X';             -- clk
			scdc_i2c_addr        : in  std_logic_vector(7 downto 0)   := (others => 'X'); -- export
			scdc_i2c_wdata       : in  std_logic_vector(7 downto 0)   := (others => 'X'); -- export
			scdc_i2c_r           : in  std_logic                      := 'X';             -- export
			scdc_i2c_w           : in  std_logic                      := 'X';             -- export
			scdc_i2c_rdata       : out std_logic_vector(7 downto 0);                      -- export
			TMDS_Bit_clock_Ratio : out std_logic;                                         -- export
			in_5v_power          : in  std_logic                      := 'X';             -- export
			in_hpd               : in  std_logic                      := 'X'              -- export
		);
	end component hdmi_rx;

	u0 : component hdmi_rx
		port map (
			reset                => CONNECTED_TO_reset,                --                reset.export
			reset_vid            => CONNECTED_TO_reset_vid,            --            reset_vid.export
			vid_clk              => CONNECTED_TO_vid_clk,              --              vid_clk.export
			ls_clk               => CONNECTED_TO_ls_clk,               --               ls_clk.export
			locked               => CONNECTED_TO_locked,               --               locked.export
			mode                 => CONNECTED_TO_mode,                 --                 mode.export
			ctrl                 => CONNECTED_TO_ctrl,                 --                 ctrl.export
			vid_lock             => CONNECTED_TO_vid_lock,             --             vid_lock.export
			vid_de               => CONNECTED_TO_vid_de,               --               vid_de.export
			vid_data             => CONNECTED_TO_vid_data,             --             vid_data.export
			vid_hsync            => CONNECTED_TO_vid_hsync,            --            vid_hsync.export
			vid_vsync            => CONNECTED_TO_vid_vsync,            --            vid_vsync.export
			in_b                 => CONNECTED_TO_in_b,                 --                 in_b.export
			in_r                 => CONNECTED_TO_in_r,                 --                 in_r.export
			in_g                 => CONNECTED_TO_in_g,                 --                 in_g.export
			in_lock              => CONNECTED_TO_in_lock,              --              in_lock.export
			aux_valid            => CONNECTED_TO_aux_valid,            --            aux_valid.export
			aux_data             => CONNECTED_TO_aux_data,             --             aux_data.export
			aux_sop              => CONNECTED_TO_aux_sop,              --              aux_sop.export
			aux_eop              => CONNECTED_TO_aux_eop,              --              aux_eop.export
			aux_error            => CONNECTED_TO_aux_error,            --            aux_error.export
			gcp                  => CONNECTED_TO_gcp,                  --                  gcp.export
			info_avi             => CONNECTED_TO_info_avi,             --             info_avi.export
			info_vsi             => CONNECTED_TO_info_vsi,             --             info_vsi.export
			aux_pkt_addr         => CONNECTED_TO_aux_pkt_addr,         --         aux_pkt_addr.export
			aux_pkt_data         => CONNECTED_TO_aux_pkt_data,         --         aux_pkt_data.export
			aux_pkt_wr           => CONNECTED_TO_aux_pkt_wr,           --           aux_pkt_wr.export
			audio_CTS            => CONNECTED_TO_audio_CTS,            --            audio_CTS.export
			audio_N              => CONNECTED_TO_audio_N,              --              audio_N.export
			audio_data           => CONNECTED_TO_audio_data,           --           audio_data.export
			audio_de             => CONNECTED_TO_audio_de,             --             audio_de.export
			audio_info_ai        => CONNECTED_TO_audio_info_ai,        --        audio_info_ai.export
			audio_metadata       => CONNECTED_TO_audio_metadata,       --       audio_metadata.export
			audio_format         => CONNECTED_TO_audio_format,         --         audio_format.export
			scdc_i2c_clk         => CONNECTED_TO_scdc_i2c_clk,         --         scdc_i2c_clk.clk
			scdc_i2c_addr        => CONNECTED_TO_scdc_i2c_addr,        --        scdc_i2c_addr.export
			scdc_i2c_wdata       => CONNECTED_TO_scdc_i2c_wdata,       --       scdc_i2c_wdata.export
			scdc_i2c_r           => CONNECTED_TO_scdc_i2c_r,           --           scdc_i2c_r.export
			scdc_i2c_w           => CONNECTED_TO_scdc_i2c_w,           --           scdc_i2c_w.export
			scdc_i2c_rdata       => CONNECTED_TO_scdc_i2c_rdata,       --       scdc_i2c_rdata.export
			TMDS_Bit_clock_Ratio => CONNECTED_TO_TMDS_Bit_clock_Ratio, -- TMDS_Bit_clock_Ratio.export
			in_5v_power          => CONNECTED_TO_in_5v_power,          --          in_5v_power.export
			in_hpd               => CONNECTED_TO_in_hpd                --               in_hpd.export
		);

