module ep_g3x8_avmmdma256_integrated_DUT (
		input  wire         refclk,                    //            refclk.clk,                       Check User Guide for details
		output wire         coreclkout_hip,            //    coreclkout_hip.clk,                       Check User Guide for details
		input  wire         npor,                      //              npor.npor,                      Check User Guide for details
		input  wire         pin_perst,                 //                  .pin_perst,                 Check User Guide for details
		output wire         app_nreset_status,         // app_nreset_status.reset_n,                   Check User Guide for details
		input  wire         ninit_done,                //        ninit_done.ninit_done,                Check User Guide for details
		output wire [63:0]  rd_dma_address_o,          //     dma_rd_master.address,                   Check User Guide for details
		output wire         rd_dma_write_o,            //                  .write,                     Check User Guide for details
		output wire [255:0] rd_dma_write_data_o,       //                  .writedata,                 Check User Guide for details
		input  wire         rd_dma_wait_request_i,     //                  .waitrequest,               Check User Guide for details
		output wire [4:0]   rd_dma_burst_count_o,      //                  .burstcount,                Check User Guide for details
		output wire [31:0]  rd_dma_byte_enable_o,      //                  .byteenable,                Check User Guide for details
		input  wire         rd_dts_chip_select_i,      //      rd_dts_slave.chipselect,                Check User Guide for details
		input  wire         rd_dts_write_i,            //                  .write,                     Check User Guide for details
		input  wire [4:0]   rd_dts_burst_count_i,      //                  .burstcount,                Check User Guide for details
		input  wire [7:0]   rd_dts_address_i,          //                  .address,                   Check User Guide for details
		input  wire [255:0] rd_dts_write_data_i,       //                  .writedata,                 Check User Guide for details
		output wire         rd_dts_wait_request_o,     //                  .waitrequest,               Check User Guide for details
		output wire [63:0]  rd_dcm_address_o,          //     rd_dcm_master.address,                   Check User Guide for details
		output wire         rd_dcm_write_o,            //                  .write,                     Check User Guide for details
		output wire [31:0]  rd_dcm_writedata_o,        //                  .writedata,                 Check User Guide for details
		output wire         rd_dcm_read_o,             //                  .read,                      Check User Guide for details
		output wire [3:0]   rd_dcm_byte_enable_o,      //                  .byteenable,                Check User Guide for details
		input  wire         rd_dcm_wait_request_i,     //                  .waitrequest,               Check User Guide for details
		input  wire [31:0]  rd_dcm_read_data_i,        //                  .readdata,                  Check User Guide for details
		input  wire         rd_dcm_read_data_valid_i,  //                  .readdatavalid,             Check User Guide for details
		output wire [63:0]  wr_dma_address_o,          //     dma_wr_master.address,                   Check User Guide for details
		output wire         wr_dma_read_o,             //                  .read,                      Check User Guide for details
		input  wire [255:0] wr_dma_read_data_i,        //                  .readdata,                  Check User Guide for details
		input  wire         wr_dma_wait_request_i,     //                  .waitrequest,               Check User Guide for details
		output wire [4:0]   wr_dma_burst_count_o,      //                  .burstcount,                Check User Guide for details
		input  wire         wr_dma_read_data_valid_i,  //                  .readdatavalid,             Check User Guide for details
		output wire [31:0]  wr_dma_byte_enable_o,      //                  .byteenable,                Check User Guide for details
		input  wire         wr_dts_chip_select_i,      //      wr_dts_slave.chipselect,                Check User Guide for details
		input  wire         wr_dts_write_i,            //                  .write,                     Check User Guide for details
		input  wire [4:0]   wr_dts_burst_count_i,      //                  .burstcount,                Check User Guide for details
		input  wire [7:0]   wr_dts_address_i,          //                  .address,                   Check User Guide for details
		input  wire [255:0] wr_dts_write_data_i,       //                  .writedata,                 Check User Guide for details
		output wire         wr_dts_wait_request_o,     //                  .waitrequest,               Check User Guide for details
		output wire [63:0]  wr_dcm_address_o,          //     wr_dcm_master.address,                   Check User Guide for details
		output wire         wr_dcm_write_o,            //                  .write,                     Check User Guide for details
		output wire [31:0]  wr_dcm_writedata_o,        //                  .writedata,                 Check User Guide for details
		output wire         wr_dcm_read_o,             //                  .read,                      Check User Guide for details
		output wire [3:0]   wr_dcm_byte_enable_o,      //                  .byteenable,                Check User Guide for details
		input  wire         wr_dcm_wait_request_i,     //                  .waitrequest,               Check User Guide for details
		input  wire [31:0]  wr_dcm_read_data_i,        //                  .readdata,                  Check User Guide for details
		input  wire         wr_dcm_read_data_valid_i,  //                  .readdatavalid,             Check User Guide for details
		input  wire [63:0]  txs_address_i,             //               txs.address,                   Check User Guide for details
		input  wire         txs_chipselect_i,          //                  .chipselect,                Check User Guide for details
		input  wire [3:0]   txs_byteenable_i,          //                  .byteenable,                Check User Guide for details
		output wire [31:0]  txs_readdata_o,            //                  .readdata,                  Check User Guide for details
		input  wire [31:0]  txs_writedata_i,           //                  .writedata,                 Check User Guide for details
		input  wire         txs_read_i,                //                  .read,                      Check User Guide for details
		input  wire         txs_write_i,               //                  .write,                     Check User Guide for details
		output wire         txs_readdatavalid_o,       //                  .readdatavalid,             Check User Guide for details
		output wire         txs_waitrequest_o,         //                  .waitrequest,               Check User Guide for details
		output wire [63:0]  rxm_bar4_address_o,        //          rxm_bar4.address,                   Check User Guide for details
		output wire [3:0]   rxm_bar4_byteenable_o,     //                  .byteenable,                Check User Guide for details
		input  wire [31:0]  rxm_bar4_readdata_i,       //                  .readdata,                  Check User Guide for details
		output wire [31:0]  rxm_bar4_writedata_o,      //                  .writedata,                 Check User Guide for details
		output wire         rxm_bar4_read_o,           //                  .read,                      Check User Guide for details
		output wire         rxm_bar4_write_o,          //                  .write,                     Check User Guide for details
		input  wire         rxm_bar4_readdatavalid_i,  //                  .readdatavalid,             Check User Guide for details
		input  wire         rxm_bar4_waitrequest_i,    //                  .waitrequest,               Check User Guide for details
		input  wire         simu_mode_pipe,            //          hip_ctrl.simu_mode_pipe,            Check User Guide for details
		input  wire [66:0]  test_in,                   //                  .test_in,                   Check User Guide for details
		input  wire         sim_pipe_pclk_in,          //          hip_pipe.sim_pipe_pclk_in,          Check User Guide for details
		output wire [1:0]   sim_pipe_rate,             //                  .sim_pipe_rate,             Check User Guide for details
		output wire [5:0]   sim_ltssmstate,            //                  .sim_ltssmstate,            Check User Guide for details
		output wire [31:0]  txdata0,                   //                  .txdata0,                   Check User Guide for details
		output wire [31:0]  txdata1,                   //                  .txdata1,                   Check User Guide for details
		output wire [31:0]  txdata2,                   //                  .txdata2,                   Check User Guide for details
		output wire [31:0]  txdata3,                   //                  .txdata3,                   Check User Guide for details
		output wire [3:0]   txdatak0,                  //                  .txdatak0,                  Check User Guide for details
		output wire [3:0]   txdatak1,                  //                  .txdatak1,                  Check User Guide for details
		output wire [3:0]   txdatak2,                  //                  .txdatak2,                  Check User Guide for details
		output wire [3:0]   txdatak3,                  //                  .txdatak3,                  Check User Guide for details
		output wire         txcompl0,                  //                  .txcompl0,                  Check User Guide for details
		output wire         txcompl1,                  //                  .txcompl1,                  Check User Guide for details
		output wire         txcompl2,                  //                  .txcompl2,                  Check User Guide for details
		output wire         txcompl3,                  //                  .txcompl3,                  Check User Guide for details
		output wire         txelecidle0,               //                  .txelecidle0,               Check User Guide for details
		output wire         txelecidle1,               //                  .txelecidle1,               Check User Guide for details
		output wire         txelecidle2,               //                  .txelecidle2,               Check User Guide for details
		output wire         txelecidle3,               //                  .txelecidle3,               Check User Guide for details
		output wire         txdetectrx0,               //                  .txdetectrx0,               Check User Guide for details
		output wire         txdetectrx1,               //                  .txdetectrx1,               Check User Guide for details
		output wire         txdetectrx2,               //                  .txdetectrx2,               Check User Guide for details
		output wire         txdetectrx3,               //                  .txdetectrx3,               Check User Guide for details
		output wire [1:0]   powerdown0,                //                  .powerdown0,                Check User Guide for details
		output wire [1:0]   powerdown1,                //                  .powerdown1,                Check User Guide for details
		output wire [1:0]   powerdown2,                //                  .powerdown2,                Check User Guide for details
		output wire [1:0]   powerdown3,                //                  .powerdown3,                Check User Guide for details
		output wire [2:0]   txmargin0,                 //                  .txmargin0,                 Check User Guide for details
		output wire [2:0]   txmargin1,                 //                  .txmargin1,                 Check User Guide for details
		output wire [2:0]   txmargin2,                 //                  .txmargin2,                 Check User Guide for details
		output wire [2:0]   txmargin3,                 //                  .txmargin3,                 Check User Guide for details
		output wire         txdeemph0,                 //                  .txdeemph0,                 Check User Guide for details
		output wire         txdeemph1,                 //                  .txdeemph1,                 Check User Guide for details
		output wire         txdeemph2,                 //                  .txdeemph2,                 Check User Guide for details
		output wire         txdeemph3,                 //                  .txdeemph3,                 Check User Guide for details
		output wire         txswing0,                  //                  .txswing0,                  Check User Guide for details
		output wire         txswing1,                  //                  .txswing1,                  Check User Guide for details
		output wire         txswing2,                  //                  .txswing2,                  Check User Guide for details
		output wire         txswing3,                  //                  .txswing3,                  Check User Guide for details
		output wire [1:0]   txsynchd0,                 //                  .txsynchd0,                 Check User Guide for details
		output wire [1:0]   txsynchd1,                 //                  .txsynchd1,                 Check User Guide for details
		output wire [1:0]   txsynchd2,                 //                  .txsynchd2,                 Check User Guide for details
		output wire [1:0]   txsynchd3,                 //                  .txsynchd3,                 Check User Guide for details
		output wire         txblkst0,                  //                  .txblkst0,                  Check User Guide for details
		output wire         txblkst1,                  //                  .txblkst1,                  Check User Guide for details
		output wire         txblkst2,                  //                  .txblkst2,                  Check User Guide for details
		output wire         txblkst3,                  //                  .txblkst3,                  Check User Guide for details
		output wire         txdataskip0,               //                  .txdataskip0,               Check User Guide for details
		output wire         txdataskip1,               //                  .txdataskip1,               Check User Guide for details
		output wire         txdataskip2,               //                  .txdataskip2,               Check User Guide for details
		output wire         txdataskip3,               //                  .txdataskip3,               Check User Guide for details
		output wire [1:0]   rate0,                     //                  .rate0,                     Check User Guide for details
		output wire [1:0]   rate1,                     //                  .rate1,                     Check User Guide for details
		output wire [1:0]   rate2,                     //                  .rate2,                     Check User Guide for details
		output wire [1:0]   rate3,                     //                  .rate3,                     Check User Guide for details
		output wire         rxpolarity0,               //                  .rxpolarity0,               Check User Guide for details
		output wire         rxpolarity1,               //                  .rxpolarity1,               Check User Guide for details
		output wire         rxpolarity2,               //                  .rxpolarity2,               Check User Guide for details
		output wire         rxpolarity3,               //                  .rxpolarity3,               Check User Guide for details
		output wire [2:0]   currentrxpreset0,          //                  .currentrxpreset0,          Check User Guide for details
		output wire [2:0]   currentrxpreset1,          //                  .currentrxpreset1,          Check User Guide for details
		output wire [2:0]   currentrxpreset2,          //                  .currentrxpreset2,          Check User Guide for details
		output wire [2:0]   currentrxpreset3,          //                  .currentrxpreset3,          Check User Guide for details
		output wire [17:0]  currentcoeff0,             //                  .currentcoeff0,             Check User Guide for details
		output wire [17:0]  currentcoeff1,             //                  .currentcoeff1,             Check User Guide for details
		output wire [17:0]  currentcoeff2,             //                  .currentcoeff2,             Check User Guide for details
		output wire [17:0]  currentcoeff3,             //                  .currentcoeff3,             Check User Guide for details
		output wire         rxeqeval0,                 //                  .rxeqeval0,                 Check User Guide for details
		output wire         rxeqeval1,                 //                  .rxeqeval1,                 Check User Guide for details
		output wire         rxeqeval2,                 //                  .rxeqeval2,                 Check User Guide for details
		output wire         rxeqeval3,                 //                  .rxeqeval3,                 Check User Guide for details
		output wire         rxeqinprogress0,           //                  .rxeqinprogress0,           Check User Guide for details
		output wire         rxeqinprogress1,           //                  .rxeqinprogress1,           Check User Guide for details
		output wire         rxeqinprogress2,           //                  .rxeqinprogress2,           Check User Guide for details
		output wire         rxeqinprogress3,           //                  .rxeqinprogress3,           Check User Guide for details
		output wire         invalidreq0,               //                  .invalidreq0,               Check User Guide for details
		output wire         invalidreq1,               //                  .invalidreq1,               Check User Guide for details
		output wire         invalidreq2,               //                  .invalidreq2,               Check User Guide for details
		output wire         invalidreq3,               //                  .invalidreq3,               Check User Guide for details
		input  wire [31:0]  rxdata0,                   //                  .rxdata0,                   Check User Guide for details
		input  wire [31:0]  rxdata1,                   //                  .rxdata1,                   Check User Guide for details
		input  wire [31:0]  rxdata2,                   //                  .rxdata2,                   Check User Guide for details
		input  wire [31:0]  rxdata3,                   //                  .rxdata3,                   Check User Guide for details
		input  wire [3:0]   rxdatak0,                  //                  .rxdatak0,                  Check User Guide for details
		input  wire [3:0]   rxdatak1,                  //                  .rxdatak1,                  Check User Guide for details
		input  wire [3:0]   rxdatak2,                  //                  .rxdatak2,                  Check User Guide for details
		input  wire [3:0]   rxdatak3,                  //                  .rxdatak3,                  Check User Guide for details
		input  wire         phystatus0,                //                  .phystatus0,                Check User Guide for details
		input  wire         phystatus1,                //                  .phystatus1,                Check User Guide for details
		input  wire         phystatus2,                //                  .phystatus2,                Check User Guide for details
		input  wire         phystatus3,                //                  .phystatus3,                Check User Guide for details
		input  wire         rxvalid0,                  //                  .rxvalid0,                  Check User Guide for details
		input  wire         rxvalid1,                  //                  .rxvalid1,                  Check User Guide for details
		input  wire         rxvalid2,                  //                  .rxvalid2,                  Check User Guide for details
		input  wire         rxvalid3,                  //                  .rxvalid3,                  Check User Guide for details
		input  wire [2:0]   rxstatus0,                 //                  .rxstatus0,                 Check User Guide for details
		input  wire [2:0]   rxstatus1,                 //                  .rxstatus1,                 Check User Guide for details
		input  wire [2:0]   rxstatus2,                 //                  .rxstatus2,                 Check User Guide for details
		input  wire [2:0]   rxstatus3,                 //                  .rxstatus3,                 Check User Guide for details
		input  wire         rxelecidle0,               //                  .rxelecidle0,               Check User Guide for details
		input  wire         rxelecidle1,               //                  .rxelecidle1,               Check User Guide for details
		input  wire         rxelecidle2,               //                  .rxelecidle2,               Check User Guide for details
		input  wire         rxelecidle3,               //                  .rxelecidle3,               Check User Guide for details
		input  wire [1:0]   rxsynchd0,                 //                  .rxsynchd0,                 Check User Guide for details
		input  wire [1:0]   rxsynchd1,                 //                  .rxsynchd1,                 Check User Guide for details
		input  wire [1:0]   rxsynchd2,                 //                  .rxsynchd2,                 Check User Guide for details
		input  wire [1:0]   rxsynchd3,                 //                  .rxsynchd3,                 Check User Guide for details
		input  wire         rxblkst0,                  //                  .rxblkst0,                  Check User Guide for details
		input  wire         rxblkst1,                  //                  .rxblkst1,                  Check User Guide for details
		input  wire         rxblkst2,                  //                  .rxblkst2,                  Check User Guide for details
		input  wire         rxblkst3,                  //                  .rxblkst3,                  Check User Guide for details
		input  wire         rxdataskip0,               //                  .rxdataskip0,               Check User Guide for details
		input  wire         rxdataskip1,               //                  .rxdataskip1,               Check User Guide for details
		input  wire         rxdataskip2,               //                  .rxdataskip2,               Check User Guide for details
		input  wire         rxdataskip3,               //                  .rxdataskip3,               Check User Guide for details
		input  wire [5:0]   dirfeedback0,              //                  .dirfeedback0,              Check User Guide for details
		input  wire [5:0]   dirfeedback1,              //                  .dirfeedback1,              Check User Guide for details
		input  wire [5:0]   dirfeedback2,              //                  .dirfeedback2,              Check User Guide for details
		input  wire [5:0]   dirfeedback3,              //                  .dirfeedback3,              Check User Guide for details
		input  wire         sim_pipe_mask_tx_pll_lock, //                  .sim_pipe_mask_tx_pll_lock, Check User Guide for details
		input  wire         rx_in0,                    //        hip_serial.rx_in0,                    Check User Guide for details
		input  wire         rx_in1,                    //                  .rx_in1,                    Check User Guide for details
		input  wire         rx_in2,                    //                  .rx_in2,                    Check User Guide for details
		input  wire         rx_in3,                    //                  .rx_in3,                    Check User Guide for details
		output wire         tx_out0,                   //                  .tx_out0,                   Check User Guide for details
		output wire         tx_out1,                   //                  .tx_out1,                   Check User Guide for details
		output wire         tx_out2,                   //                  .tx_out2,                   Check User Guide for details
		output wire         tx_out3                    //                  .tx_out3,                   Check User Guide for details
	);
endmodule

