// (C) 2001-2018 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


`timescale 1ns / 1ns
module alt_e40_core_jke64uy  #(
    parameter SIM_EMULATE           = 1'b0,
    parameter SIM_SHORT_AM          = 1'b0,
    parameter SYNOPT_LINK_FAULT     = 1'b0,
    parameter DYNAMIC_SKEW          = 1'b0,
    parameter TARGET_CHIP           = 6,
    parameter EXT_TX_PLL            = 1,
    parameter SYNOPT_TXCRC_INS      = 1,
    parameter SYNOPT_PREAMBLE_PASS  = 0,
    parameter SYNOPT_MAC_STATS      = 1,
    parameter SYNOPT_FLOW_CONTROL   = 0,
    parameter SYNOPT_NUMPRIORITY    = 8,
    parameter SYNOPT_STRICT_SOP     = 0,
    parameter SYNOPT_READY_LATENCY  = 0,
    parameter STATUS_CLK_KHZ        = 100000,     // clk_status rate in Mhz
    parameter ENABLE_KR4            = 0, 
    parameter SYNTH_AN              = 0,
    parameter SYNTH_SEQ             = 0,
    parameter LINK_TIMER_KR         = 513,
    parameter AN_TECH               = 8,
    parameter AN_CHAN               = 2,
    parameter AN_PAUSE              = 2,
    parameter SYNTH_LT              = 0,
    parameter BERWIDTH              = 4,
    parameter VMAXRULE              = 30,
    parameter VMINRULE              = 6,
    parameter VODMINRULE            = 14,
    parameter VPOSTRULE             = 25,
    parameter VPRERULE              = 16,
    parameter PREMAINVAL            = 30,
    parameter PREPOSTVAL            = 0,
    parameter PREPREVAL             = 0,
    parameter INITMAINVAL           = 25,
    parameter INITPOSTVAL           = 13,
    parameter INITPREVAL            = 3,
    parameter TRNWTWIDTH            = 8,
    parameter MAINTAPWIDTH          = 5,
    parameter POSTTAPWIDTH          = 6,
    parameter PRETAPWIDTH           = 5,
    parameter USE_DEBUG_CPU         = 0,
    parameter SYNTH_FEC             = 0,
    parameter CAPABLE_FEC           = 0,
    parameter ENABLE_FEC            = 0
) (

    input  [SYNOPT_NUMPRIORITY-1:0] pause_insert_tx0,
    input  [SYNOPT_NUMPRIORITY-1:0] pause_insert_tx1,
    output [SYNOPT_NUMPRIORITY-1:0] pause_receive_rx,

    input                   tx_fabric_pll_locked,
    input                   l2_tx_error,
    input                   l2_tx_startofpacket,
    input                   l2_tx_endofpacket,
    input                   l2_tx_valid,
    output                  l2_tx_ready,
    input      [3:0]        l2_tx_empty,
    input      [2*64-1:0]   l2_tx_data,
    output                  tx_lanes_stable,

    output      [39:0]      l2_txstatus_data,
    output                  l2_txstatus_valid,
    output      [6:0]       l2_txstatus_error,

    input     [63:0]        l2_tx_preamble,
    output     [63:0]       l2_rx_preamble,

    output                  remote_fault_status,
    output                  local_fault_status,
    output                  unidirectional_en,
    output                  link_fault_gen_en,

    output      [39:0]      l2_rxstatus_data,
    output                  l2_rxstatus_valid,

    output     [5:0]        l2_rx_error,
    output                  l2_rx_valid,
    output                  l2_rx_startofpacket,
    output                  l2_rx_endofpacket,
    output     [2*64-1:0]   l2_rx_data,
    output     [3:0]        l2_rx_empty,

    input           avmm_write,
    input           avmm_read,
    input   [15:0]  avmm_address,
    input   [31:0]  avmm_write_data,
    output  [31:0]  avmm_read_data,
    output          avmm_read_data_valid,
    output          avmm_waitrequest,

    // Incoming rcfg REQ from TOP
    input                       reconfig_write_top,
    input                       reconfig_read_top,
    input       [12:0]          reconfig_address_top,
    input       [31:0]          reconfig_writedata_top,


    // Incoming from HSSI 
    input       [31:0]          reconfig_readdata_pma,
    input                       reconfig_waitrequest_pma,
    // ARB output to HSSI/TOP
    output                      reconfig_write_arb,
    output                      reconfig_read_arb,
    output      [12:0]          reconfig_address_arb,
    output      [31:0]          reconfig_writedata_arb,
    output                      reconfig_waitrequest_arb,

    input   [3:0]   rx_pempty,
    input   [3:0]   rx_pfull,
    input   [3:0]   rx_empty,
    input   [3:0]   rx_full,
    output          rx_set_locktoref,
    output          rx_set_locktodata,
    output  [3:0]   rx_enh_clr_errblk_count,
    input   [3:0]   rx_enh_blk_lock,
    input   [3:0]   tx_pempty,
    input   [3:0]   tx_pfull,
    input   [3:0]   tx_empty,
    input   [3:0]   tx_full,
    input           tx_pll_locked,
    output  [3:0]   rx_seriallpbken,
    input           tx_digitalreset,
    input           tx_digitalreset_pma,
    input           rx_digitalreset_pma,

    output soft_tx_rst,
    output                  inhibit_rx_reset,
    output                  inhibit_slip,

    input           clk_avmm,
    input           csr_rst_n,
    input           rx_rst,
    input           tx_rst,
    input           tx_digital_reset_status,
    input           rx_pcs_pll_locked,
    output          xcvr_rx_dig_rst_out,
    output          native_phy_reset,

    input           tx_clk,
    input  [3:0]    tx_pma_ready,
    output          tx_kr4_ready,
    input           rx_cdr_refclk,
    output [66*4-1:0]  tx_pcs_data,
    output [3:0]    tx_pcs_valid,
    output [3:0]    tx_err_ins,

    input           rx_ready,
    input  [3:0]    rx_pma_ready,
    output          rx_kr4_ready,
    input           rx_clk              ,
    input   [66*4-1:0] rx_din              ,
    input   [3:0]   rx_din_valid,

    output  [3:0]    rx_cdr_locked_kr4,
    output           start_reset_ctrl,
    output           start_reset_ctrl_rx,
    output           start_reset_ctrl_tx_d,
    output           start_reset_ctrl_tx_aib,
    output           start_reset_ctrl_tx_pcs,
    input            reset_aib_ack,
    input            reset_pcs_ack,

    input   [3:0]   tx_clkout,
    input   [3:0]   rx_clkout,
    output  [3:0]   tx_coreclkin,
    output  [3:0]   rx_coreclkin,

    //input           rpcs_purge_fifo     ,
    //output  [3:0]   rpcs_sticky_frm_err ,
    input   [3:0]   rx_is_lockedtodata  ,
    input   [3:0]   rx_is_lockedtoref  ,
    input   [3:0]   rx_analogreset_stat,
    input   [3:0]   tx_analogreset_stat,
    input   [3:0]   rx_digitalreset_stat,
    input   [3:0]   tx_digitalreset_stat,
    input   [3:0]   rx_cal_busy,
    input   [3:0]   tx_cal_busy,
// RX IOPLL/FPLL calibration done signal for KR
    input           rxpll_recal_done, 

    output  [3:0]   rpcs_word_locked    ,   //need to address
    output          rpcs_deskew_locked  ,   // these signals
    output          rpcs_align_locked   ,   // later
    output  [3:0]   rpcs_bit_slip       ,
    output          rpcs_hi_ber         ,
    output          rpcs_blk_err        ,
    output  [3:0]   rfifo_rd_en,
    output          rx_pcs_ready        
);

wire soft_rx_rst;     // TODO: connect to csr
//wire soft_tx_rst;     // TODO: connect to csr
wire csr_rst_out;               // TODO: connect to csr
wire rx_mac_sclr;                // TODO: connect to mac
wire tx_mac_rst;                // TODO: connect to mac
wire tx_pcs_rst;
assign tx_lanes_stable = (&tx_pma_ready) & tx_fabric_pll_locked;
wire    sys_rst;

//-------------------------------------------------------
//----------- Signals between PCS and MAC ---------------
//-------------------------------------------------------

wire  [127:0]   tx_pcs_din;
wire  [ 15:0]   tx_pcs_cin;
wire            tx_pcs_din_am;

wire  [127:0]   rpcs_dout_d;
wire  [15:0]    rpcs_dout_c;
wire            rpcs_am;

//------------------------------------------
//------------- MAC Module -----------------
//------------------------------------------
    // TODO : ADD MAC


    wire [15:0] mac_avmm_addr = avmm_address;
    wire        mac_avmm_write;
    wire [31:0] mac_avmm_write_data = avmm_write_data;
    wire        mac_avmm_read;
    wire [31:0] mac_avmm_read_data;
    wire        mac_avmm_read_data_valid;
    wire        mac_avmm_waitrequest;
    //wire        rx_is_lockeddt = &rx_is_lockedtodata;
    wire        rx_is_lockeddt = rx_pcs_pll_locked;

    alt_e40_mac  #(
        .SIM_SHORT_AM              (SIM_SHORT_AM), // shorten the AM interval to lock faster
        .SIM_EMULATE               (SIM_EMULATE),
        .SYNOPT_PREAMBLE_PASS      (SYNOPT_PREAMBLE_PASS),
        .SYNOPT_TXCRC_PASS         (SYNOPT_TXCRC_INS ? 1'b0 : 1'b1),
        .SYNOPT_LINK_FAULT         (SYNOPT_LINK_FAULT),
        .SYNOPT_FLOW_CONTROL       (SYNOPT_FLOW_CONTROL),
        .SYNOPT_READY_LATENCY      (SYNOPT_READY_LATENCY),
        .TARGET_CHIP               (TARGET_CHIP),
        .SYNOPT_MAC_STATS_COUNTERS (SYNOPT_MAC_STATS),
 	.SYNOPT_STRICT_SOP     ( SYNOPT_STRICT_SOP),     
        .SYNOPT_NUMPRIORITY        (SYNOPT_NUMPRIORITY)

    ) mac (
        
        .tx_clk              (tx_clk),
        .rx_clk              (rx_clk),

        .clk_status          (clk_avmm),

        .tx_mac_sclr         (tx_mac_rst),
        .rx_mac_sclr         (rx_mac_sclr),
        .csr_reset           (csr_rst_out),
        .tx_pll_locked       (tx_fabric_pll_locked ),
        .rx_is_lockeddt      (rx_is_lockeddt ), 
        .mac_avmm_addr       (mac_avmm_addr),
        .mac_avmm_write      (mac_avmm_write),
        .mac_avmm_write_data (mac_avmm_write_data),
        .mac_avmm_read       (mac_avmm_read),
        .mac_avmm_read_data  (mac_avmm_read_data),
        .mac_avmm_read_data_valid    (mac_avmm_read_data_valid),
        .mac_avmm_waitrequest(mac_avmm_waitrequest),                 

        .l2_tx_data          (l2_tx_data),
        .l2_tx_empty         (l2_tx_empty),
        .l2_tx_error         (l2_tx_error),
        .l2_tx_startofpacket (l2_tx_startofpacket),
        .l2_tx_endofpacket   (l2_tx_endofpacket),
        .l2_tx_ready         (l2_tx_ready),
        .l2_tx_valid         (l2_tx_valid),

        .l2_rx_data          (l2_rx_data),
        .l2_rx_empty         (l2_rx_empty),
        .l2_rx_startofpacket (l2_rx_startofpacket),
        .l2_rx_endofpacket   (l2_rx_endofpacket),
        .l2_rx_valid         (l2_rx_valid),
        .l2_rx_error         (l2_rx_error),
        .l2_tx_preamble      (l2_tx_preamble),
        .l2_rx_preamble      (l2_rx_preamble),
    
        .l2_rxstatus_data    (l2_rxstatus_data),
        .l2_rxstatus_valid   (l2_rxstatus_valid),
        .l2_txstatus_data    (l2_txstatus_data),
        .l2_txstatus_error   (l2_txstatus_error),
        .l2_txstatus_valid   (l2_txstatus_valid),

    // Link fault status

        .remote_fault_status (remote_fault_status),
        .local_fault_status  (local_fault_status),
        .unidirectional_en   (unidirectional_en),
        .link_fault_gen_en   (link_fault_gen_en),

    // RX Data -- Remove these. connect directly to rx_mac
        .rx_eeop             (), //LEFT UNCONNECTED IN TOP MODULE

    // To TX PCS

        .txpcs_din_d         (tx_pcs_din),
        .txpcs_din_c         (tx_pcs_cin),
        .txpcs_din_am        (tx_pcs_din_am),

    // From RX PCS

        .rxpcs_dout_am       (rpcs_am),
        .rxpcs_dout_d        (rpcs_dout_d),
        .rxpcs_dout_c        (rpcs_dout_c),

// Flow control interface
        .pause_insert_tx0    (pause_insert_tx0),
        .pause_insert_tx1    (pause_insert_tx1),
        .pause_receive_rx    (pause_receive_rx)
    );

//------------------------------------------
//------------- PCS Module -----------------
//------------------------------------------

localparam NUM_CHANNELS = 4;
reg  [NUM_CHANNELS-1:0] pma_wr_en;
wire [NUM_CHANNELS-1:0] fifo_dc_rx_full, pma_rd_en, fifo_dc_rx_empty,rx_pempty_pcs;
reg  [NUM_CHANNELS-1:0] fifo_dc_rx_wr, pma_rd_en1, pma_rd_en2;
wire [NUM_CHANNELS-1:0] fifo_dc_tx_wr, fifo_dc_tx_full,fifo_dc_tx_rd, fifo_dc_tx_empty; 
reg  [NUM_CHANNELS-1:0] fifo_tx_aclr1, fifo_tx_aclr2, fifo_tx_aclr3, fifo_tx_aclr4;
reg  [NUM_CHANNELS-1:0] fifo_rx_aclr1, fifo_rx_aclr2, fifo_rx_aclr3, fifo_rx_aclr4;


//////////////////////////////////
//// Temporary Connections
//// Remove them after MAC and CSR blocks are present
    
// CSR temporary connections
/*

assign  tx_pcs_din = {16{8'h07}};
assign  tx_pcs_cin = {4{4'hf}} ;

// MAC temporary connections

wire tx_pre_am;

alt_e40_metronome512 mt0 (
    .clk(tx_clk),
    .sclr(tx_mac_rst),
    .dout(tx_pre_am)
);
defparam mt0 .SIM_EMULATE = SIM_EMULATE;

// stretch to 2 cycles  (4 tags on 2 lanes)
wire tx_pre_am_str;
alt_e40_pulse2 ps0 (
    .clk(tx_clk),
    .din(tx_pre_am),
    .dout(tx_pcs_din_am)
);
defparam ps0 .SIM_EMULATE = SIM_EMULATE;

reg tx_am;
always @(posedge tx_clk) tx_am <= tx_pcs_din_am;
*/

    wire [15:0] pcs_avmm_addr = avmm_address;
    wire        pcs_avmm_write;
    wire [31:0] pcs_avmm_write_data = avmm_write_data;
    wire        pcs_avmm_read;
    wire [31:0] pcs_avmm_read_data;
    wire        pcs_avmm_read_data_valid;
    wire        pcs_avmm_waitrequest;
    wire        xcvr_rx_sclr;
    wire [66*4-1:0] tx_pcs_data_nonkr;
    wire [66*4-1:0] rx_din_to_pcs;
    wire [66*4-1:0] rx_din_to_pcs_fifo;
    wire [66*4-1:0] tx_dout_from_fifo;
    wire            rx_set_locktoref_csr, rx_set_locktodata_csr;
    wire [3:0]      pcs_bit_slip;
    wire            tx_pcs_valid_pcsclk;
    wire [3:0]      rx_din_valid_pcsclk, rfifo_rd_en_pcsclk;

alt_e40_pcs #(
    .SIM_EMULATE            (SIM_EMULATE),
    .SIM_SHORT_AM           (SIM_SHORT_AM),
    .SYNOPT_LINK_FAULT      (SYNOPT_LINK_FAULT),
    .DYNAMIC_SKEW           (DYNAMIC_SKEW),
    .TARGET_CHIP            (TARGET_CHIP)
) pcs (
    // All signals synchronous to tx_clk
    .tx_clk                         (tx_clk),
    .rx_cdr_refclk                  (rx_cdr_refclk),
    .clk_status                     (clk_avmm),
    .csr_reset                      (csr_rst_out),
    .pcs_avmm_write                 (pcs_avmm_write),
    .pcs_avmm_read                  (pcs_avmm_read),
    .pcs_avmm_addr                  (pcs_avmm_addr),
    .pcs_avmm_write_data            (pcs_avmm_write_data),
    .pcs_avmm_read_data             (pcs_avmm_read_data),
    .pcs_avmm_read_data_valid       (pcs_avmm_read_data_valid),
    .pcs_avmm_waitrequest           (pcs_avmm_waitrequest),
    .soft_txp_rst                   (soft_tx_rst),
    .soft_rxp_rst                   (soft_rx_rst),
    .eio_sys_rst                    (sys_rst), 
    .inhibit_rx_reset       (inhibit_rx_reset), 
    .inhibit_slip           (inhibit_slip), 
    .rx_pempty                      (rx_pempty_pcs),
    .rx_pfull                       (rx_pfull),
    .rx_empty                       (fifo_dc_rx_empty),
    .rx_full                        (fifo_dc_rx_full),
    .rx_pcs_ready                   (rx_pcs_ready),
    .rx_set_locktoref               (rx_set_locktoref_csr),
    .rx_set_locktodata              (rx_set_locktodata_csr),
    .rx_is_lockedtodata             (rx_is_lockedtodata)  ,
    .tx_pempty                      (tx_pempty),
    .tx_pfull                       (tx_pfull),
    .tx_empty                       (tx_empty),
    .tx_full                        (tx_full),
    .tx_pll_locked                  (tx_pll_locked),
    .rx_seriallpbken                (rx_seriallpbken),
    .tx_digitalreset                (tx_digitalreset),
    .tx_pcs_sclr            (tx_pcs_rst),
    .tx_pcs_din             (tx_pcs_din),
    .tx_pcs_cin             (tx_pcs_cin),
    .tx_pcs_din_am          (tx_pcs_din_am),
    .tx_pcs_dout            (tx_pcs_data_nonkr),
    .tx_pcs_valid           (tx_pcs_valid_pcsclk),

    .rx_clk                 (rx_clk),
    .rx_din                 (rx_din_to_pcs_fifo),
    .rpcs_sclr              (rx_pcs_sclr),
    .xcvr_sclr              (xcvr_rx_sclr),
    .rpcs_word_locked       (rpcs_word_locked),
    .rpcs_deskew_locked     (rpcs_deskew_locked),
    .rpcs_align_locked      (rpcs_align_locked),
    .rpcs_am                (rpcs_am),
    .rpcs_bit_slip          (pcs_bit_slip),
    .rpcs_rst_req           (rpcs_rst_req),
    .rpcs_dout_d            (rpcs_dout_d),
    .rpcs_dout_c            (rpcs_dout_c),
    .rpcs_hi_ber            (rpcs_hi_ber),
    .rpcs_blk_err           (rpcs_blk_err),
    .rfifo_rd_en            (rfifo_rd_en_pcsclk),
    .rx_din_valid           (rx_din_valid_pcsclk)
);

// FIFOs are only needed for KR4 mode to meet timing
// FEC (no AN/LT) does not require this
genvar i;
generate 
  if (SYNTH_SEQ)  begin : KR4_FIFO

     reg [NUM_CHANNELS-1:0] din_phase, din_phase_tx;
     reg [NUM_CHANNELS*3-1:0] rd_en, rd_en_tx ;
    (* altera_attribute = "-name FORCE_HYPER_REGISTER_FOR_PERIPHERY_CORE_TRANSFER ON" *)
     reg [NUM_CHANNELS-1:0]   rx_empty_reg; 
     reg [NUM_CHANNELS-1:0]   tx_full_reg; 
     // FIFO resets whenever XCVR reset- cannot wait until rx-ready else PMA RX-FIFO overflows    
     // So use digital-reset instead. Anyways nothing start until PMA RX_FIFO is ~empty
     // FIFO has reset-syn to sync this on appropriate domain
     //                             HSSI RST               PLL Lock ( Anything that resets PMA)
     wire trigger_tx_pcs_reset =  tx_digitalreset_pma || !tx_fabric_pll_locked;
     wire trigger_rx_pcs_reset =  rx_digitalreset_pma || !rx_pcs_pll_locked;
     assign rx_fifo_aclr = trigger_rx_pcs_reset;
     assign tx_fifo_aclr = trigger_tx_pcs_reset;
    // resync tx/rx-aclr on different domains before using      
     alt_e40_reset_synchronizer alt_e40_reset_synchronizer_tx_core (
      .aclr      (tx_fifo_aclr),
      .clk       (tx_coreclkin[0]), // all coreclk are same
      .aclr_sync (tx_fifo_aclr_tx_core)    
     );
     alt_e40_reset_synchronizer alt_e40_reset_synchronizer_tx_clk  (
      .aclr      (tx_fifo_aclr),
      .clk       (tx_clk), 
      .aclr_sync (tx_fifo_aclr_tx_clk)    
     );
     alt_e40_reset_synchronizer alt_e40_reset_synchronizer_rx_core (
      .aclr      (rx_fifo_aclr),
      .clk       (rx_coreclkin[0]), // all coreclk are same
      .aclr_sync (rx_fifo_aclr_rx_core)    
     );
     for (i = 0; i < NUM_CHANNELS; i=i+1) begin : channel_loop
      // pipeline empty signal from HSSI for timing
     always @(posedge rx_coreclkin[i]) rx_empty_reg[i] <= rx_empty[i] ;
      // fifo read logic -- backup a bit to have few words
     always @(posedge rx_coreclkin[i]) din_phase[i] <= ~din_phase[i] && ( !(|fifo_dc_rx_full) && !(|rx_empty_reg));
     always @(posedge rx_coreclkin[i]) begin
         if (rx_fifo_aclr_rx_core)  rd_en[3*(i + 1)-1:3*i]   <= 3'b000;
         else    rd_en[3*(i + 1)-1:3*i]  <=  {rd_en[3*(i + 1)-2:3*i], din_phase[i]} ;
     end
     /// RX FIFO
     /// Receives data from RX pipeline Reg on Gated Clock
     /// Sends data to RX PCS on no-Gated Clock
     /// wordsize = 67 = 66 Data + 1 Valid
       
     // RX-DC_FIFO-WR = Delay pma_rd_en by 3 cycles -
     // One cycle to get data out from PMA, two more cycles for pipeline flops
       always @ (posedge rx_coreclkin[i] )  begin
       pma_rd_en2[i] <= pma_rd_en1[i];	  
       pma_rd_en1[i] <= pma_rd_en[i];	  
       fifo_dc_rx_wr[i] <= pma_rd_en2[i];	  
       end	
     
       fifo_dc_67 fifo_dc_rx (
        .data    ({rx_din_valid[i],rx_din_to_pcs[66*(i + 1)-1:66*i]}),
        .wrreq   (fifo_dc_rx_wr[i]),
        .rdreq   (rfifo_rd_en_pcsclk[i]),
        .wrclk   (rx_coreclkin[i]),
        .rdclk   (rx_clk),
        .aclr    (rx_fifo_aclr), // No need to use sync'ed version since FIFOs have resync built-in
        .q       ({rx_din_valid_pcsclk[i],rx_din_to_pcs_fifo[66*(i + 1)-1:66*i]}),
        .rdusedw (/*open*/),
        .wrusedw (/*open*/),
        .rdempty (fifo_dc_rx_empty[i]),
        .wrfull  (fifo_dc_rx_full[i])
       );
     //-----------------
     // FIFO data becomes available on next cycle
     // so pass RD through flop -- becomes WR for next stage (PMA) FIFO
       always @ (posedge tx_coreclkin[i] )  begin
         pma_wr_en[i] <= fifo_dc_tx_rd[i] ;
       end
     /// TX FIFO
     /// Receives data from PCS 
     /// Sends data to TX pipeline Reg on Gated-Clock
     always @ (posedge tx_clk) begin
      fifo_tx_aclr1[i] <=  tx_fifo_aclr_tx_clk;
      fifo_tx_aclr2[i] <=  fifo_tx_aclr1[i];
      fifo_tx_aclr3[i] <=  fifo_tx_aclr2[i];
      fifo_tx_aclr4[i] <=  fifo_tx_aclr3[i];
     end
      // fifo read logic -- backup a bit to have few words
      // pipeline empty signal from HSSI for timing
     always @(posedge tx_coreclkin[i]) tx_full_reg[i] <= tx_full[i] ;
     //always @(posedge tx_coreclkin[i]) din_phase_tx[i] <= ~din_phase_tx[i] && ( !fifo_dc_tx_empty[i] && !tx_full_reg[i]);
     //always @(posedge tx_coreclkin[i]) din_phase_tx[i] <= ~din_phase_tx[i] && ( !fifo_dc_tx_empty[i] && !tx_full[i]);
     always @(posedge tx_coreclkin[i]) din_phase_tx[i] <= ~din_phase_tx[i] && !fifo_dc_tx_empty[i] ;
     always @(posedge tx_coreclkin[i]) begin
         if (tx_fifo_aclr_tx_core)  rd_en_tx[3*(i + 1)-1:3*i]   <= 3'b000;
         else    rd_en_tx[3*(i + 1)-1:3*i]  <=  {rd_en_tx[3*(i + 1)-2:3*i], din_phase_tx[i]} ;
     end
     assign  fifo_dc_tx_rd[i] = rd_en_tx[3*(i + 1)-1];
       assign fifo_dc_tx_wr[i] = tx_pcs_valid_pcsclk && ! fifo_dc_tx_full[i] && !fifo_tx_aclr4[i]; 
       fifo_dc_66 fifo_dc_tx (
        .data    (tx_pcs_data_nonkr[66*(i + 1)-1:66*i]),
        .wrreq   (fifo_dc_tx_wr[i]),
        .rdreq   (fifo_dc_tx_rd[i]),
        .wrclk   (tx_clk),
        .rdclk   (tx_coreclkin[i]),
        .aclr    (tx_fifo_aclr), // No need to use sync'ed version since FIFOs have resync built-in
        .q       (tx_dout_from_fifo[66*(i + 1)-1:66*i]),       // fifo_output.dataout
        .rdusedw (/*open*/),
        .wrusedw (/*open*/),
        .rdempty (fifo_dc_tx_empty[i]),
        .wrfull  (fifo_dc_tx_full[i])
       );  
     end
    assign tx_pcs_valid = pma_wr_en;
    assign  pma_rd_en = {rd_en[11],rd_en[8],rd_en[4],rd_en[1]};
    assign rfifo_rd_en  = pma_rd_en;
    assign rx_pempty_pcs     = rx_empty_reg;// send pcs reg version of empty (actually pempty if you track level above)
 end
 else begin  : NO_FIFO
    assign tx_pcs_valid    = {4{tx_pcs_valid_pcsclk}};
    assign rfifo_rd_en     = rfifo_rd_en_pcsclk;
    assign fifo_dc_rx_empty= rx_empty;
    assign fifo_dc_rx_full = rx_full;
    assign rx_din_valid_pcsclk = rx_din_valid ;
    assign rx_din_to_pcs_fifo =  rx_din_to_pcs;
    assign tx_dout_from_fifo  = tx_pcs_data_nonkr; 
    assign rx_pempty_pcs     = rx_pempty;
 end
endgenerate

  wire  reserved_avmm_read;
  reg   reserved_avmm_data_valid;
  always @(posedge clk_avmm)
  	 reserved_avmm_data_valid <= reserved_avmm_read;
//------------------------------------------
//------------- KR4 Module -----------------
//------------------------------------------

    wire [31:0] kr4_avmm_read_data;
    wire        kr4_avmm_waitrequest,kr4_avmm_read_data_valid;
    wire            kr4_avmm_write, kr4_avmm_read;
generate 
  if (ENABLE_KR4)  begin : KR4_LAYER_INST
    wire [66*4-1:0] tx_pcs_data_kr;

    assign kr4_avmm_write   =   ((avmm_address[15:8] ==  8'h00) && (avmm_address[7:4] >= 4'hB)) && avmm_write;
    assign kr4_avmm_read    =   ((avmm_address[15:8] ==  8'h00) && (avmm_address[7:4] >= 4'hB)) && avmm_read ;

   alt_e40_s10_kr4_jke64uy # (
         .SYNTH_AN         (SYNTH_AN),
         .SYNTH_LT         (SYNTH_LT),
         .SYNTH_SEQ        (SYNTH_SEQ),
         .SYNTH_FEC        (SYNTH_FEC),
         .LINK_TIMER_KR    (LINK_TIMER_KR),
         .BERWIDTH         (BERWIDTH),
         .TRNWTWIDTH       (TRNWTWIDTH),
         .MAINTAPWIDTH     (MAINTAPWIDTH),
         .POSTTAPWIDTH     (POSTTAPWIDTH),
         .PRETAPWIDTH      (PRETAPWIDTH),
         .VMAXRULE         (VMAXRULE),
         .VMINRULE         (VMINRULE),
         .VODMINRULE       (VODMINRULE),
         .VPOSTRULE        (VPOSTRULE),
         .VPRERULE         (VPRERULE),
         .PREMAINVAL       (PREMAINVAL),
         .PREPOSTVAL       (PREPOSTVAL),
         .PREPREVAL        (PREPREVAL),
         .INITMAINVAL      (INITMAINVAL),
         .INITPOSTVAL      (INITPOSTVAL),
         .INITPREVAL       (INITPREVAL),
         .USE_DEBUG_CPU    (USE_DEBUG_CPU),
         .AN_CHAN          (AN_CHAN),
         .AN_PAUSE         (AN_PAUSE),
         .AN_TECH          (AN_TECH),
         .CAPABLE_FEC      (CAPABLE_FEC),
         .ENABLE_FEC       (ENABLE_FEC),
         .MGMT_CLK_IN_KHZ  (STATUS_CLK_KHZ)
     ) s10_kr4 (         
        .pma_arst(~csr_rst_n || !rxpll_recal_done),   // asynchronous reset CSRs, hold KR in reset when csr_rst_n is active or rxpll_recal_done is 0
        .usr_an_lt_reset(~csr_rst_n || !rxpll_recal_done),
        .usr_seq_reset(~csr_rst_n || !rxpll_recal_done),
        .clk_status(clk_avmm), // management/csr clock (for status_ bus)
        
        // 66 bit data words on clk_tx
        .clk_tx(tx_clk),      // tx parallel data clock
        .tx_pll_lock(tx_pll_locked),            // plls locked (async signal)
        .tx_datain(tx_dout_from_fifo),
        
        // 66 bit data words on clk_rx
        .clk_rx(rx_clk),        // rx parallel data clock
        .pcs_bit_slip (pcs_bit_slip), // Bitslip from PCS
        .kr4_bit_slip (rpcs_bit_slip), // Bitslip from KR- LT
        .rx_is_lockedtodata_hssi(rx_is_lockedtodata)  ,
        .rx_is_lockedtoref_hssi (rx_is_lockedtoref)  ,
        .rx_analogreset_ack_hssi(rx_analogreset_stat)  ,
        .tx_analogreset_ack_hssi(tx_analogreset_stat)  ,
        .rx_digitalreset_ack_hssi(rx_digitalreset_stat)  ,
        .tx_digitalreset_ack_hssi(tx_digitalreset_stat)  ,
        .lanes_deskewed(rpcs_deskew_locked & rx_ready), // indicates RX lock in 40G data mode
        .rx_cal_busy_hssi (rx_cal_busy),
        .tx_cal_busy_hssi (tx_cal_busy),
       // Reset Controller connections
        .tx_pma_ready   (tx_pma_ready),
        .rx_pma_ready   (rx_pma_ready),
        .tx_kr4_ready   (tx_kr4_ready), // ready && DATA-MODE
        .rx_kr4_ready   (rx_kr4_ready), // ready && DATA-MODE
        .rx_cdr_locked  (rx_cdr_locked_kr4),
        .start_reset_ctrl(start_reset_ctrl),
        .start_reset_ctrl_rx    (start_reset_ctrl_rx),
        .start_reset_ctrl_tx_d  (start_reset_ctrl_tx_d),
        .start_reset_ctrl_tx_aib (start_reset_ctrl_tx_aib),
        .start_reset_ctrl_tx_pcs (start_reset_ctrl_tx_pcs),
        .reset_aib_ack        (reset_aib_ack),
        .reset_pcs_ack        (reset_pcs_ack),

        // Signals to and from HSSI 
        .tx_10g_clkout(tx_clkout),
        .rx_10g_clkout(rx_clkout),
        .tx_10g_coreclkin(tx_coreclkin),
        .rx_10g_coreclkin(rx_coreclkin),
        .rx_parallel_data(rx_din),
        .rx_parallel_data_from_kr4(rx_din_to_pcs),
        .tx_parallel_data(tx_pcs_data_kr),
        .fec_tx_err_ins(tx_err_ins), 
        
        // ultra access to hssi
        .tx_pcs_valid({4{tx_pcs_valid_pcsclk}}),

        .set_lock_data(rx_set_locktodata_csr),
        .set_lock_ref(rx_set_locktoref_csr),
        .rx_set_locktodata(rx_set_locktodata),
        .rx_set_locktoref (rx_set_locktoref ),
        .rx_enh_clr_errblk_count(rx_enh_clr_errblk_count),
        .rx_enh_blk_lock (rx_enh_blk_lock),
        
        // avalon_mm (on clk_status)
        .status_read(kr4_avmm_read),
        .status_write(kr4_avmm_write),
        .status_addr(avmm_address[7:0]),
        .status_readdata(kr4_avmm_read_data),
        .status_writedata(avmm_write_data),
        .status_readdata_valid(kr4_avmm_read_data_valid),
        .status_waitrequest(kr4_avmm_waitrequest),
        
    
    // RCFG connections to HSSI
        .chnl_rcfg_read(reconfig_read_arb),
        .chnl_rcfg_address(reconfig_address_arb),
        .chnl_rcfg_write(reconfig_write_arb),
        .chnl_rcfg_wrdata(reconfig_writedata_arb),
        .chnl_rcfg_rddata(reconfig_readdata_pma),
        .chnl_rcfg_waitrequest(reconfig_waitrequest_pma),
    
    // external HSSI REQ inputs for arbiteration
        // hssi reconfig access (on clk_status, NOT reconfig_clk!!!)
        //.reconfig_clk(reconfig_clk),                  // input  wire [0:0]   
        .reconfig_write(reconfig_write_top),                // input  wire [0:0]   
        .reconfig_read(reconfig_read_top),                  // input  wire [0:0]   
        .reconfig_address(reconfig_address_top),            // input  wire [11:0]  
        .reconfig_writedata(reconfig_writedata_top),        // input  wire [31:0]  
        .reconfig_waitrequest(reconfig_waitrequest_arb)     // output wire [0:0]   
        

    );

   // pass on TX_DATA From KR to HSSI since datamux is pressent in KR module
   assign tx_pcs_data = tx_pcs_data_kr;   
  end
  else begin  : NON_KR4
   // pass on TX_DATA From PCS to HSSI in non-KR mode
   assign tx_pcs_data               = tx_dout_from_fifo;   
   assign rx_din_to_pcs             = rx_din;
   assign rpcs_bit_slip             = pcs_bit_slip;
   assign tx_coreclkin              = {4{tx_clk}};
   assign rx_coreclkin              = {4{rx_clk}};
   assign rx_set_locktodata         = rx_set_locktodata_csr;
   assign rx_set_locktoref          = rx_set_locktoref_csr;
   assign rx_enh_clr_errblk_count   = 1'b0;  
   assign reconfig_write_arb       = 1'b0;
   assign reconfig_read_arb        = 1'b0;
   assign reconfig_address_arb     =13'b0;
   assign reconfig_writedata_arb   =32'b0;
   assign reconfig_waitrequest_arb = 1'b0;
   assign kr4_avmm_read_data       = 32'hdeadc0de;
   assign kr4_avmm_read_data_valid = reserved_avmm_data_valid;
   assign kr4_avmm_waitrequest     = 1'b0; 
   assign tx_kr4_ready             = 1'b0;
   assign rx_kr4_ready             = 1'b0;
   assign rx_cdr_locked_kr4        = 4'b0;
   assign tx_err_ins               = 4'b0;   
   assign start_reset_ctrl         = 1'b0; 
   assign start_reset_ctrl_rx      = 1'b0; 
   assign start_reset_ctrl_tx_d    = 1'b1; 
  end
endgenerate
//------------------------------------------
//------- Central Reset Controller ---------
//------------------------------------------
alt_e40_reset_controller reset_controler (
    .rst_clk                (clk_avmm),
    .rx_clk                 (rx_clk),
    .tx_clk                 (tx_clk),
    .csr_rst_in             (~csr_rst_n),
    .xcvr_rx_dig_rst_in     (rpcs_rst_req),
    .tx_fabric_pll_locked   (tx_fabric_pll_locked),
    .sys_rst                (sys_rst),
    .rx_rst                 (rx_rst),
    .tx_rst                 (tx_rst),
    .rx_pcs_ready_in        (rpcs_align_locked),
    .rx_ready               (rx_ready),
    .soft_rx_rst            (soft_rx_rst),
    .soft_tx_rst            (soft_tx_rst),
    .csr_rst_out            (csr_rst_out),
    .xcvr_rx_dig_rst_out    (xcvr_rx_dig_rst_out),
    .native_phy_reset       (native_phy_reset),
    .xcvr_rx_sclr           (xcvr_rx_sclr),
    .rx_pcs_pll_locked      (rx_pcs_pll_locked),
    .rx_pcs_sclr             (rx_pcs_sclr),
    .rx_mac_sclr             (rx_mac_sclr),
    .rx_pcs_ready_out       (rx_pcs_ready),
    .tx_pcs_sclr             (tx_pcs_rst),
    .tx_mac_sclr             (tx_mac_rst),
    .tx_digitalreset        (tx_digital_reset_status)
);


  //------------------------------------------
  //------------- CSR MUX Module -------------
  //------------------------------------------
 // Add KR4 muxing only if KR4 is enabled
generate 
  if (ENABLE_KR4)  begin : MUXING_FOR_KR4
    assign reserved_avmm_read = avmm_read & ! (pcs_avmm_read | mac_avmm_read | kr4_avmm_read);
    assign  avmm_read_data  =   pcs_avmm_read_data_valid   ?   pcs_avmm_read_data  :
                                mac_avmm_read_data_valid  ?   mac_avmm_read_data  :   kr4_avmm_read_data_valid ? kr4_avmm_read_data: 32'hdeadc0de;
    assign  avmm_read_data_valid    =    pcs_avmm_read_data_valid | mac_avmm_read_data_valid | kr4_avmm_read_data_valid | reserved_avmm_data_valid;
    assign  avmm_waitrequest    =   (avmm_address[15:8] ==  8'h03)  ?   pcs_avmm_waitrequest    :
                                    ((avmm_address[15:8] >=  8'h04)  && (avmm_address[15:8] <= 8'h09)) ?   mac_avmm_waitrequest :   
                                     ((avmm_address[15:8] ==  8'h00) && (avmm_address[7:4] >= 4'hB)) ? kr4_avmm_waitrequest : !(avmm_read | avmm_write);
  end else begin : MUXING_FOR_40G
    assign reserved_avmm_read = avmm_read & ! (pcs_avmm_read | mac_avmm_read);
    assign  avmm_read_data  =    pcs_avmm_read_data_valid ?   pcs_avmm_read_data  :   mac_avmm_read_data_valid? mac_avmm_read_data : 32'hdeadc0de;
    assign  avmm_read_data_valid    =   pcs_avmm_read_data_valid | mac_avmm_read_data_valid | reserved_avmm_data_valid;
    assign  avmm_waitrequest    =   (avmm_address[15:8] ==  8'h03)  ?   pcs_avmm_waitrequest    :   
    	    			    ((avmm_address[15:8] >=  8'h04)  && (avmm_address[15:8] <= 8'h09)) ? mac_avmm_waitrequest : !(avmm_read | avmm_write);
  end
endgenerate


    assign pcs_avmm_write   =   (avmm_address[15:8] ==  8'h03)  && avmm_write;
    assign mac_avmm_write   =   ((avmm_address[15:8] >=  8'h04) && (avmm_address[15:8] <= 8'h09)) && avmm_write;

    assign pcs_avmm_read    =   (avmm_address[15:8] ==  8'h03)  && avmm_read;
    assign mac_avmm_read    =   ((avmm_address[15:8] >=  8'h04) && (avmm_address[15:8] <= 8'h09)) && avmm_read;

endmodule

